//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

function BlogAPIDetector() {
}

BlogAPIDetector.prototype = 
{
    _req: null,
    _title: null,

    getTitle: function()
    {
        return this._title;
    },
    doRequest: function(listener, url, processor)
    {
        var inst = this;
        this._req = new XMLHttpRequest();
        this._req.onreadystatechange = function (aEvt) 
        {
            try
            {
                if(inst._req.readyState == 4) 
                {
                    if(inst._req.status == 200)
                    {
                        try
                        {
                            var result = processor(listener, inst)
                        }
                        catch(e)
                        {
                            listener.onError(e);
                        }
                    }
                    else
                    {
                        listener.onError(inst._req.status);
                    }
                }
            }
            catch(e)
            {
                listener.onError(-1);
            }
        };
        this._req.open('GET', url, true);
        this._req.send(null); 
    },
    detect: function(listener, url)
    {
        this.doRequest(listener, url, this.onHomePage);
    },
    onHomePage: function (listener, inst)
    {
        /*
         * The following code is to clean up shitty html to make it parser
           friendly
         */
        var req = inst._req;          
        var properHeader = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">";
        var text = properHeader + "\n" + "<html xmlns=\"http://www.w3.org/1999/xhtml\"><head>\n"

        
        var title_html = "";
        if(req.responseText.match(/(<title.*>.+?>)/))
        {
            title_html = RegExp.$1;
        }
        text += title_html;

        var R = /<link.+?>/g;
        for(;;)
        {
            var ar = R.exec(req.responseText);
            if(!ar) break;
            var cur = ar[0] + "";
            if(!cur.match(/\/>/))
            {
              cur = cur.replace(/>/,"/>");
            }
            text += cur + "\n";
        }
        text += "</head></html>";
        var parser = new DOMParser();
        var resultDoc = parser.parseFromString(text,"text/xml");
        if(!resultDoc)
        {
            listener.onError(null);
            return;
        }

        //ANTHONY: FIGURE OUT HOW TO PUT THE TITLE ON AUTODETECT SHIT
        var title_n = resultDoc.getElementsByTagName("title");
        if(title_n.length)
        {
            if(title_n[0].firstChild)
            {
                inst._title = title_n[0].firstChild.nodeValue;
            }
        }

        var linklist = resultDoc.getElementsByTagName("link");
        for(var i=0;i<linklist.length;++i)
        {
            var link = linklist[i]; 
            var url = link.href;
            if(!url) continue;

            if(link.type=="application/atom+xml" && link.rel=="service.post")
            {
                /*
                 * Blogger Atom API, what else
                 */

                var rval = new Array();
                var B = new AtomAPI();
                B.init("atom", "", url, "", "", "");
                rval[0] = B;
                listener.onAPI(rval);
                return;
            }
            else if(link.rel=="pingback")
            {
                /*
                 * Wordpress, what else
                 */
                var rval = new Array();
                var B = new MetaweblogAPI();
                B.init("metaweblog", "", url, "", "", "");
                rval[0] = B;
                listener.onAPI(rval);
                return;

            }
            else if(link.title=="RSD")
            {
                /*
                 * Blogger xml-rpc service discovery
                 */
                inst.doRequest(listener, url, inst.onIntrospect);
                return;
            }
        }
        listener.onAPI(null);
    },
    onIntrospect: function (listener, inst)
    {
        try
        {
            var req = inst._req;
            var apis = req.responseXML.getElementsByTagName("api");

            var rval = new Array();
            for(var i=0;i<apis.length;++i)
            {
                var name = apis[i].getAttribute("name").toLowerCase();
                if(name=="atom") continue;

                var apiLink = apis[i].getAttribute("apiLink");
                var preferred = apis[i].getAttribute("preferred");
                var blogID = apis[i].getAttribute("blogID");
                var B = null;
                if(name=="blogger") {
                    B = new BloggerAPI();
                }
                if(name=="metaweblog") {
                    B = new MetaweblogAPI();
                }
                if(name=="movabletype") {
                    B = new MovableTypeAPI();
                }
                B.init(name, "", apiLink, blogID, preferred);
                rval[rval.length] = B;
            }
            listener.onAPI(rval);
        } 
        catch(e) {
            //alert(e + " " + e.fileName + " " + e.lineNumber);
        }
    },
}
