//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


var gB = null;
var gBlogTitle = "";
var gBlogURL = "";
var gBlogUser = "";
var gBlogPassword = "";
var gDetect = null;
var gBlogs = null;

function flock_blogWizardLoad()
{
    if(window.arguments && window.arguments.length)
    {
        var arg = window.arguments[0];
        $("blog-wizard-url").value = arg;
        $("blogAccountWizard").advance();
    }
}

function fillFinalUI2(api)
{
    $("blog-username").value = gBlogUser;
    $("blog-password").value = gBlogPassword;
    $("blog-uri").value =  api.apiLink;

    var blogid = api.blogID;
    if(api.blogID.length==0) api.blogID = "1";
    $("blog-blogid").value =  blogid;
}

function fillFinalUI()
{
    if(gB)
    {
        if(gB.name=="atom")
        {
            $("blog-api-menu").selectedIndex = 4;
            fillFinalUI2(gB);
            return;
        }
        if(gB.name=="movabletype")
        {
            $("blog-api-menu").selectedIndex = 3;
            fillFinalUI2(gB);
            return;
        }
        if(gB.name=="metaweblog")
        {
            $("blog-api-menu").selectedIndex = 2;
            fillFinalUI2(gB);
            return;
        }
        if(gB.name=="blogger")
        {
            $("blog-api-menu").selectedIndex = 1;
            fillFinalUI2(gB);
            return;
        }
    }
}

function blogWizardStartAdvance()
{
    flock_blogInitRDF();
    gBlogURL = $("blog-wizard-url").value;
    gB = null;
    gDetect = new BlogAPIDetector();
    try
    {
        gDetect.detect(new detectListener(), gBlogURL);
        $("blogAccountWizard").canAdvance = false;
        $("blogAccountWizard").canRewind = false;
    }
    catch(e)
    {
        alert("The URL you have entered is not valid.  Please try again");
        throw "Musn't advance";
    }
}

function blogWizardDetectAdvance()
{
    try
    {
        if(gB)
        {
            $("blogWizardConfirmSettings").setAttribute("label", "Blog API Detected!");
            $("blogWizardConfirmSettings").setAttribute("description", "Flock has detected your API settings.  Please click next to continue.");
        }
        else
        {
            $("blogWizardConfirmSettings").setAttribute("label", "Blog API Configuration");
            $("blogWizardConfirmSettings").setAttribute("description", "Please enter your blog XML-RPC information below.");
        }
    }
    catch(e)
    {
        alert(e);
    }

    fillFinalUI();
}

function blogWizardDetectRewind()
{
    window.location.reload();
}


function blogWizardConfirmSettingsAdvance()
{
    if(!gB)//should this be unconditional?
    {
        var B = null;
        var name = $("blog-api-menu").value;

        if(name=="atom") {
            B = new AtomAPI();
        }
        if(name=="blogger") {
            B = new BloggerAPI();
        }
        if(name=="metaweblog") {
            B = new MetaweblogAPI();
        }
        if(name=="movabletype") {
            B = new MovableTypeAPI();
        }

        B.init(name, "", $("blog-uri").value, $("blog-blogid").value, true);

        gB = B;

    }
}

function blogTitleAdvance()
{
}

function blogWizardPasswordAdvance()
{
    gBlogUser = $("blog-wizard-user").value;
    gBlogPassword = $("blog-wizard-password").value;
    $("blog-username").value = gBlogUser;
    $("blog-password").value = gBlogPassword;

    if(gB)
    {
        gB.setAuth(gBlogUser,gBlogPassword);
        gB.getUsersBlogs(new flock_blogWizardUsersBlogsListener());//todo: make this a preference
        $("blogAccountWizard").canAdvance = false;
    }
}

function blogWizardTestAdvance()
{
}

function blogOptionsAdvance()
{
}

function blogWizardSaveAccount(aTitle, aAPIName, aAPILink, aBlogID)
{
    var ds = flock_blogGetDS();
    var bloguri = BLOG_URN_ROOT + aTitle;
    flock_blogRemoveSettings(bloguri);
    var u = $("blog-username").value;
    var p = $("blog-password").value;
    var blogurl = $("blog-wizard-url").value;
    flock_blogAddAccount(aTitle, u, p, true, blogurl);//this url is out of date
    flock_blogAddAPI(aTitle, aAPIName, aAPILink, aBlogID);
}

function blogWizardFinalAdvance()
{
    /*
     * Here, go ahead and set the default account to be the last added account
     */
    var count = flock_blogAccountCount();
    flock_blogSetDefaultAccountIndex(count-1);
    window.close();
}

function detectListener()
{
}

detectListener.prototype = 
{
    onAPI: function(apis) 
    {
        for(var i=0;i<apis.length;++i)
        {
            if(apis[i].name=="metaweblog")
            {
                gB = apis[i]; break;
            }
            if(apis[i].name=="movabletype")
            {
                gB = apis[i]; break;
            }
            if(apis[i].name=="atom")
            {
                gB = apis[i]; break;
            }
            if(apis[i].name=="blogger")
            {
                gB = apis[i]; break;
            }
        }
        if(gB.name=="atom")
        {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").canRewind = true;
            $("blog-nonatom-container").collapsed = true;
            $("blogAccountWizard").advance();
            $("blogAccountWizard").advance();
            $("blogAccountWizard").advance();
        }
        else
        {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").advance();
        }

        fillFinalUI();
        return;

    },

    onError: function (errorMsg) 
    {
        if(confirm("There was an error detecting your blog settings\n Click OK to try again, or cancel to manually configure your blog.")) {
            $("blogAccountWizard").rewind();
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").canRewind = true;
        }
        else
        {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").advance();
        }

    }
};

function testListener()
{
}

testListener.prototype = 
{
    onResult: function(result) 
    {
        //OK
        var title = BLOG_URN_ROOT + $("blog-title").value;
        var loader = new flock_blogPostListingListener(title, 25);
        loader.didUpdate = true;
        loader.onResult(result);
        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").advance();
    },

    onFault: function (fault)
    {
        //Error
        this.handleError(error);
    },

    onError: function (error)
    {
        //Error
        this.handleError(error);
    },
    handleError: function (error)
    {
        if(confirm("There was an error detecting your blog settings\n Click OK to try again, or cancel to manually configure your blog.")) {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").rewind();
        }
        else
        {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").advance();
        }
    }
}

/*
function flock_duplicateCrappily(aObj)
{
    var obj = new Object();
    for(var p in aObj)
    {
        obj[p] = aObj[p];
    }
    return obj;
}
*/

function flock_blogWizardUsersBlogsListener()
{
}

flock_blogWizardUsersBlogsListener.prototype = 
{
    onResult: function(result) 
    {
        // Return value: on success, array of structs containing String url, String blogid, String blogName; on failure, fault
        gBlogs = new Array();
        for(var i=0;i<result.length;++i)
        {
            var url = result[i].url;
            var blogid = result[i].blogid;
            var blogName = result[i].blogName;
            var apiLink = gB.apiLink;
            if(gB.name=="atom") apiLink = url;// Atom uses a url model for posting
            blogWizardSaveAccount(blogName, gB.name, apiLink, blogid);
        }

        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").advance();
        return;

        var title = BLOG_URN_ROOT + $("blog-title").value;
        var loader = new flock_blogPostListingListener(title, 25);
        loader.didUpdate = true;
        loader.onResult(result);
        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").advance();
    },

    onFault: function (fault)
    {
        //Error
        alert("There was and error detecting your blog settings\n" + fault.faultString);
        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").rewind();
    },

    onError: function (error)
    {
        //Error
        alert("There was and error detecting your blog settings\n");
        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").rewind();
    }
}
