//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


var gDots = 3;
var gTimeout = 1000;
var gClose = false;

function flock_closeWatch()
{
    if(gClose)
    {
        window.close();
    }
    else
    {
        window.setTimeout("flock_closeWatch();", 300);
    }
}

function flock_blogDoDots()
{
    if(gClose) return;
    if(gDots>3)
    {
        gDots = 1;
    }
    var str = "";
    for(var i=0;i<gDots;++i)
    {
        str += "."; 
    }
    ++gDots;
    $("blog-dots").setAttribute("value", str);
    //alert($("blog-dots").value);
    window.setTimeout("flock_blogDoDots();", gTimeout);
}

function _flock_blogLoadPosts()
{
    try
    {
        var title = window.arguments[0];
        gSelectedBlog = title;
        var listener = new postListingListener2(title, true);
        flock_blogSetupProfiles();
        var B = gBlogProfiles[title];
        B.getRecentPosts(listener, 50);//todo: make this a preference
    }
    catch(e)
    {
        alert(e);
    }
}
function flock_blogLoadPosts()
{
    window.setTimeout("flock_blogDoDots();", gTimeout);
    window.setTimeout("_flock_blogLoadPosts();", 100);
    window.setTimeout("flock_closeWatch();", 300);
}

function postListingListener2(selectedBlog, force_update)
{
    this.selectedBlog = selectedBlog;
    this.force_update = force_update;
}

postListingListener2.prototype = 
{
    selectedBlog: null,
    force_update: null,
    onResult: function(result) 
    {
        if(!result)
        {
            alert("returning on parser error");
            // THIS IS REALLY A PARSER ERROR!
            return;
        }
        var data = result;
        for(var i=0;i<data.length;++i)
        {
            var posturi = "urn:r2:blog:settings:" + this.selectedBlog + ":posts:" + data[i].postid;
            var date = new Date(data[i].dateCreated);

            if(!this.force_update && postExists(posturi))
            {
                continue;
            }

            if(data[i].dateCreated)
            {
                //alert(data[i].dateCreated);
            }

            var mycontent = null;
            if(data[i].content)
            {
                mycontent = data[i].content;
            }

            if(data[i].description)
            {
                mycontent = data[i].description;
            }
            if(!mycontent)
            {
                // TODO:: Excerpts?
                continue;
            }
            //alert(mycontent);
            mycontent = mycontent.replace(/\r/g,"");
            mycontent = mycontent.replace(/\n/g,"<br/>");
            var title = data[i].title;
            try
            {
                //dump("aaa\n");
                var postid = data[i].postid;
                //dump("bbb\n");
                var uri = "urn:r2:blog:settings:" + this.selectedBlog + ":posts:" + postid;
                //dump("ccc\n");
                flock_blogSavePost(uri,title,mycontent,BLOG_STATE_OK, date, true);
                //dump("ddd\n");
            }
            catch(e)
            {
                alert(e + e.fileName + " " + e.lineNumber + "\n");
            }
        }
        var ds = flock_blogGetDS();
        var bloguri = "urn:r2:blog:settings:" + gSelectedBlog;
        var blog = ds.getNode(bloguri);
        blog.addTargetOnce(R2_BLOG_NS+"init", 1 + "");
        ds.save();
        gClose = true;
     },

     onFault: function (fault)
     {
        alert("There was an error retrieving your blog posts from your service.\n Please check your account information and try again");
        gClose = true;
     },

     onError: function (error)
     {
        alert("There was an error retrieving your blog posts from your service.\n It's probably the case that you entered incorrect blog settings (like the API url)");
        gClose = true;
     }
};
