//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var gBlogContent = null;
var gBlogOriginalHTML = null;
var gBlogTitle = null;
var gSelectedPost = null;
var gSelectedBlog = null;
var gBlogEditCommandController = null;

var gBlogPostData = 
{
    postid: "",
    title: "",
    html: "",
    state: "",
    date: "",
    tags: "",
    updateFunc: null,
};

const SOURCE_VIEW = "content-source";
const CONTENT_VIEW = "content-frame";
var gViewMode = CONTENT_VIEW;

/////////////////////////////////////////////////////////////////
// Initialization
/////////////////////////////////////////////////////////////////

function flock_blogEditorHasChanged() {
    var myData = {};
    flock_blogEditorUpdateGlobalPost(myData);
    for(var p in myData) {
        if((myData[p] + "") != (gBlogPostData[p] + "")) {
            return true;
        }
    }
    return false;
}

function flock_blogEditorSetView(aView) {
    flock_blogEditorUpdateView();
    gViewMode = aView;
}

function flock_blogEditorUnload() {
}

function flock_blogEditorCanClose() {
    if(flock_blogEditorHasChanged()) {
        if(confirm("Save Your Post Changes?")) flock_blogEditorSavePostCommand.exec();
    }
    top.controllers.removeController(gBlogEditCommandController);
    return true;
}

function flock_blogEditorLoad() {
    window.setTimeout("flock_blogEditorUpdateViewTimer()",0);
    window.setTimeout("_flock_blogEditorLoad()",0);
}

function flock_blogEditorGetEditor() {
    return GetCurrentEditor();
    return $(CONTENT_VIEW);
}

function flock_blogEditorGetSourceEditor() {
    return gSourceTextEditor;
    var win = $(SOURCE_VIEW);
    win.makeEditable("text", false);
    var rval = gSourceContentWindow.getEditor(gSourceContentWindow.contentWindow);
    rval.QueryInterface(Components.interfaces.nsIPlaintextEditor);
    return rval;
}

function flock_blogEditorUpdateViewTimer() {
    window.setTimeout("flock_blogEditorUpdateView()",2000);

    flock_blogEditorUpdateView();
}

function flock_blogEditorGetEditorFlags() {
    var editor = flock_blogGetEditor();
    var flags = (editor.documentCharacterSet == "ISO-8859-1")
      ? 32768  // OutputEncodeLatin1Entities
      : 16384; // OutputEncodeBasicEntities
    try { 
      var encodeEntity = gPrefs.getCharPref("editor.encode_entity");
      switch (encodeEntity) {
        case "basic"  : flags = 16384; break; // OutputEncodeBasicEntities
        case "latin1" : flags = 32768; break; // OutputEncodeLatin1Entities
        case "html"   : flags = 65536; break; // OutputEncodeHTMLEntities
        case "none"   : flags = 0;     break;
      }
    } catch (e) { }

    try { 
      var prettyPrint = gPrefs.getBoolPref("editor.prettyprint");
      if (prettyPrint)
      {
        flags |= 2; // OutputFormatted
      }

    } catch (e) {}

    flags |= 1024; // OutputLFLineBreak
    return flags;
}

function flock_blogEditorUpdateView() {
    window.setTimeout("flock_blogEditorUpdateView()",2000);

    var body = flock_blogEditorGetBody();
    if(body==gBlogContent) return;
    gBlogContent = body;

    if(gViewMode==CONTENT_VIEW) {
        flock_blogEditorGetSourceEditor().beginTransaction();
        flock_blogEditorGetSourceEditor().selectAll();
        flock_blogEditorGetSourceEditor().deleteSelection(0);
        var source = flock_blogEditorGetFormatedBody();
        source = source.replace(/<!-- flock-force -->/g,"");
        flock_blogEditorGetSourceEditor().insertText(source);
        flock_blogEditorGetSourceEditor().endTransaction();
    } else {
        flock_blogEditorGetEditor().beginTransaction();
        flock_blogEditorGetEditor().selectAll();
        flock_blogEditorGetEditor().deleteSelection(0);
        var source = flock_blogEditorGetSourceEditor().outputToString(kTextMimeType, 1024);
        flock_blogEditorGetEditor().insertHTML(source);
        flock_blogEditorGetEditor().endTransaction();
    }
}

function flock_blogEditorSelectPubState(obj)
{
    flock_blogSavePubState(gSelectedPost,obj.selectedIndex);
}

function flock_blogEditorAddTags(html)
{
    var tags = null;
    var ds = flock_blogGetDS();
    var post = ds.getNode(gSelectedPost);

    try {
        tags = post.getTarget(R2_BLOG_NS+"tags").getValue();
    }
    catch(e) {
    }

    if(!tags || tags.length==0) return html;
    var tags_ar = tags.split(",");

    var tag_html = "";
    tag_html += '<!-- technorati tags begin -->';
    tag_html += '<p style="font-size:10px;text-align:right;">Technorati Tags: ';


    for(var i=0;i<tags_ar.length;++i)
    {
        tag_html += '<a href="http://technorati.com/tag/';
        tag_html += tags_ar[i];
        tag_html += '" rel="tag">';
        tag_html += tags_ar[i];
        tag_html += '</a>';
        if(i!=tags_ar.length-1)
        {
            tag_html += ", ";
        }
    }

    tag_html += '</p>';
    tag_html +="<!-- technorati tags end -->";
    html += tag_html;
    return html;
}

function flock_blogEditorHideMozillaCrap() {
    $("editLink_cm").collapsed="true";
}

function flock_blogEditorInitUI() {
    $("flock-blog-notify-services").checked = flock_getBoolPref("blog.notify");
    var qs = new flock_PageQuery(window.location.search);

    gSelectedPost = hexDecode(qs.getValue("postid"));
    var selectedIndex = 0;

    var origShit = gSelectedPost;
//    alert(gSelectedPost);

    flock_blogEditorEditPost(gSelectedPost);

    //THis is a little hack to allow drafts to not show up in folder till saved
    if(gSelectedPost == BLOG_TMP_POST)
    {
        var tmpDate = flock_blogPostDate(BLOG_TMP_POST);
        gSelectedPost = BLOG_DRAFTS_FOLDER + "posts:" + tmpDate;
    }

    gSelectedPost.match(/(.+):posts:*/);

    gSelectedBlog = RegExp.$1;

    if(!gSelectedBlog) throw "Shoot - need a bloguri";

    var ds = flock_blogGetDS();
    var accts = $("flock-blog-accounts");
    accts.database.AddDataSource(ds.getRawDataSource());
    accts.builder.rebuild();

    selectedIndex = flock_blogGetAccountIndex(gSelectedBlog);
    if(origShit == BLOG_TMP_POST) selectedIndex = flock_blogGetDefaultAccountIndex();
    accts.selectedIndex = selectedIndex;
    if(!accts.selectedItem) accts.selectedIndex = 0;

    try {
        $("flock-blog-publish-status").selectedIndex = flock_blogPubState(gSelectedPost);
    } catch(e) { }

    flock_blogEditorSelectAccount(accts.selectedItem.label);

    flock_blogEditorUpdateGlobalPost();
    flock_blogEditorGetSourceEditor().wrapWidth  = 0;// This causes line wrapping
}

function flock_blogEditorCheckWeNeedToOpenTopbar() {
    var accountCount = flock_blogAccountCount();
    if(accountCount==1)//only drafts
    {
        flock_toggleTopbar('Blog');
    }
}

function _flock_blogEditorLoad() {
    flock_blogInit();
    flock_blogEditorSetupEditorCommands();
    flock_blogEditorInitUI();
    flock_blogEditorHideMozillaCrap();
    flock_blogEditorCheckWeNeedToOpenTopbar();
}

function flock_blogEditorSelectAccount(blog) {
    gSelectedBlog = BLOG_URN_ROOT + blog;
    var accts = $("flock-blog-accounts");
    flock_blogSetDefaultAccountIndex(accts.selectedIndex);
}

function flock_blogEditorPublishDraftAndSaveAndClose() {
    flock_blogEditorSavePostCommand.exec();
    flock_blogEditorPublishPost(0);
}

function flock_blogEditorPublishPost(aPublish) {
    try
    {

        flock_blogEditorSavePostCommand.exec();

        if(gSelectedBlog==BLOG_DRAFTS_FOLDER2) 
        {
            window.close();
            return;
        }

        var editor = GetCurrentEditor();
        var html = flock_blogEditorGetBody();
        html = flock_blogEditorAddTags(html);

        var title = document.getElementById("flock-blog-title").value;


        gSelectedPost.match(/.+:(.*)/);
        var postid = RegExp.$1;
        var state = BLOG_STATE_NEW;
        try {
            state = flock_blogPostState(gSelectedPost);
        } catch(e) {}



        var date = null;
        var newPost = null;
        if(state==BLOG_STATE_NEW) {
            newPost = true;
            date = new Date(flock_blogPostDate(BLOG_TMP_POST));
        }
        else {
            newPost = false;
            date = new Date(flock_blogPostDate(gSelectedPost));
        }

        var params = {
            newPost : newPost,
            title : title,
            date : date,
            html : html,
            publish : aPublish,
            selectedBlog : gSelectedBlog,
            selectedPost : gSelectedPost,
            postid : postid,
            newPostID : null,

            success : false,
        };

        window.openDialog("blogPublish.xul", "PublishPost", "modal,centerscreen", params);
        if(params.success) {
            if(newPost) {
                gSelectedPost = params.newPostID;
                flock_blogEditorSavePostCommand.exec();
            }
            window.close()
        }

    } 
    catch(e) {
        alert(e + " " + e.lineNumber + " " + e.fileName);
    }
}

function flock_blogEditorGetPublish() {
    var rval = false;
    if($("flock-blog-publish-status").selectedIndex==0) rval = true;
    //alert(rval);
    return rval;
}

function flock_blogEditorEditPost(posturi) {
    var editor = GetCurrentEditor();

    var ds = flock_blogGetDS();

    var post = ds.getNode(posturi);

    var content = "";
    
    try {
        content = post.getTarget(R2_BLOG_NS+"content").getValue();
    } catch(e) {}

    editor.beginTransaction();
    editor.insertHTML(content);
    editor.endTransaction();
    flock_blogEditorUpdateView();

    var title = "";
    try {
        title = post.getTarget(R2_BLOG_NS+"title").getValue();
    } catch(e) {}

    $("flock-blog-title").value = title;
    try {
        $("flock-blog-tags").loadString(flock_blogPostTags(posturi));
    } catch(e) {}

    var html = flock_blogEditorGetBody();
    gBlogOriginalHTML = html;
    flock_blogEditorUpdateGlobalPost();
}

function flock_blogEditorUpdateGlobalPost(aData) {

    var data = gBlogPostData;
    if(aData) data = aData;

    data.postid = gSelectedPost;
    data.title =  $("flock-blog-title").value;
    data.html = flock_blogEditorGetBody();
    data.state = BLOG_STATE_NEW;
    try {
        data.state = flock_blogPostState(gSelectedPost);
    } 
    catch(e) { }

    try {
        data.date = new Date(flock_blogPostDate(gSelectedPost));
    } 
    catch(e) {
        data.date = new Date(flock_blogPostDate(BLOG_TMP_POST));
    }
    data.tags = $("flock-blog-tags").toString();
    return data;
}

function flock_blogEditorGetFormatedBody() {
    return flock_blogEditorGetEditor().document.body.innerHTML;
/*
    var source = flock_blogGetEditor().outputToString(kHTMLMimeType, flock_blogGetEditorFlags());


    return source;
    var lines = source.split("\n");
    var haveBody = false;
    var rval = "";
    for(var i=0;i<lines.length;++i)
    {
        var line = lines[i];
        if(!haveBody)
        {
            if(line.match("<body>"))
            haveBody = true;
            continue;
        }
        if(line.match("</body>")) break;
        rval += line + "\n";
    }
    return rval;
*/

}

function flock_blogEditorGetBody()
{
    if(gViewMode == SOURCE_VIEW) {
        return flock_blogEditorGetSourceEditor().outputToString(kTextMimeType, 1024);
    }

    if(gViewMode == CONTENT_VIEW) {
        return flock_blogEditorGetFormatedBody();
    }
    return body;
}

/////////////////////////////////////////////////////////////////
// Helper Code
/////////////////////////////////////////////////////////////////

function flock_checkKeyPress(event) {
    return;
    switch(event.keyCode) {
    case 9:
      if (!event.shiftKey && !event.ctrlKey && !event.altKey && !event.metaKey) {
        window.content.focus();
        event.preventDefault();
      }
      break;
    case 13:
      window.content.focus();
      break;
    }
}


/////////////////////////////////////////////////////////////////
// Closing Check
/////////////////////////////////////////////////////////////////

var flock_blogEditorSavePostCommand =
{
    isEnabled: function()
    {
        return gSelectedPost != null;
    },
    exec: function()
    {
        try
        {
            flock_blogEditorUpdateGlobalPost();
            //if(gBlogPostData.updateFunc) gBlogPostData.updateFunc();
            flock_blogSavePost(gBlogPostData.postid, gBlogPostData.title, gBlogPostData.html, gBlogPostData.state, gBlogPostData.date);
            if(gBlogPostData.tags) flock_blogSavePostTags(gBlogPostData.postid, gBlogPostData.tags);
            gBlogOriginalHTML = gBlogPostData.html;
            //alert("post");
        }
        catch(e)
        {
            flock_error(e);
        }
    },
}

var flock_blogEditorPublishPostCommand =
{
    isEnabled: function()
    {
        if(!gSelectedBlog) return false;
        if(gSelectedBlog.match(BLOG_DRAFTS_FOLDER2)) return false;
        return gSelectedPost != null;
    },
    exec: function()
    {
        flock_blogEditorPublishPost(1);
    },
}

var flock_blogEditorSelectAccountCommand =
{
    isEnabled: function()
    {
        var state = BLOG_STATE_NEW
        try
        {
            state = flock_blogPostState(gSelectedPost);
        }
        catch(e){}
        if(state==BLOG_STATE_NEW)
        {
            return true;
        }
        return false;
    },
    exec: function()
    {
    },
}

function flock_blogEditorSetupEditorCommands() {
    if(gBlogEditCommandController) return;
    gBlogEditCommandController = new CommandController();

    gBlogEditCommandController.cmd_flock_blogPublishPost = flock_blogEditorPublishPostCommand;
    gBlogEditCommandController.cmd_flock_blogSavePost = flock_blogEditorSavePostCommand;
    gBlogEditCommandController.cmd_flock_blogSelectAccount = flock_blogEditorSelectAccountCommand;

    top.controllers.appendController(gBlogEditCommandController);
    window.addEventListener('focus',function () { window.document.commandDispatcher.updateCommands('focus'); },false);
    window.addEventListener('click',function () { window.document.commandDispatcher.updateCommands('click'); },false);
    window.document.commandDispatcher.updateCommands('focus');
    window.focus();
}

function flock_blogUpdateEditCommands() {
    flock_blogUpdateCommands($("flock_BlogEditCommands"), gBlogCommandController);
}

/////////////////////////////////////////////////////////////////
// Initialization
/////////////////////////////////////////////////////////////////

function flock_blogEditorMacKeyHandler(aEvent) {
    switch(aEvent.keyCode) {
        case 13: {
            aEvent.preventBubble();
            aEvent.preventDefault();
        }
    }
}

function flock_blogEditorKeyHandler(aEvent) {
    var selection = flock_blogEditorGetEditor().selection;
    var selectionNode = selection.focusNode;

    switch(aEvent.keyCode) {
        case 13: {
            if (aEvent.shiftKey) {
                // we need a non tag element to force the damned thing to
                // actually take a br!
                var forceInserter = "<!-- flock-force -->";
                flock_blogEditorGetEditor().insertHTML("<br/>" + forceInserter);
                aEvent.preventBubble();
                aEvent.preventDefault();
            } else {
                if(selectionNode.nodeName=="P") {
                    try {
                        selection.selectAllChildren(selectionNode.nextSibling);
                        selection.collapseToEnd();
                    }
                    catch(e) {
                        selection.selectAllChildren(selectionNode.parentNode);
                        selection.collapseToEnd();
                    }
                }
                flock_blogEditorGetEditor().insertHTML("<p></p>");
                aEvent.preventBubble();
                aEvent.preventDefault();
            }
        }
        break;
        default: {
        }
        break;
    }
    return true;

}
