//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var gParams = null;

function flock_blogPublishLoad() {
    if(window.arguments && window.arguments.length) {
        gParams  = window.arguments[0];
    }
    else {
        alert("Looking for something? Well I am!");
    }
    for(var p in gParams)
    {
        dump(">>>" + p + " " + gParams[p]);
    }
    
    var B = flock_blogGetAPI(gParams.selectedBlog);
    if(gParams.newPost) {
        var listener = new BlogPublishListener(gParams.selectedPost);
        B.newPost(listener, gParams.title, gParams.html, gParams.date, gParams.publish);
    }
    else {
        var listener = new BlogEditListener();
        B.editPost(listener, gParams.postid, gParams.title, gParams.html, gParams.date, gParams.publish);
    }
}

function flock_blogPublishClose(success) {
    gParams.success = success;
    window.setTimeout("window.close();",0);
}


/************************************************************************/
// XMLHTTP Listeners
/************************************************************************/

function BlogPublishListener(selectedPost) {
    this.selectedPost = selectedPost;
}

BlogPublishListener.prototype = 
{
    selectedPost: null,
    onResult: function(result) {
        var uri = this.selectedPost;
        uri.match(/(.+):(.*)/);
        var container = RegExp.$1;
        var postid = RegExp.$2;
        uri = gParams.selectedBlog + ":posts:" + result;

        var ds = flock_blogGetDS();
        var post = ds.getNode(this.selectedPost);
        var content = post.getTarget(R2_BLOG_NS+"content").getValue();
        var title = post.getTarget(R2_BLOG_NS+"title").getValue();
        var datestr = post.getTarget(R2_BLOG_NS+"date").getValue();

        gParams.newPostID = uri;
        flock_blogSavePost(uri, title, content, BLOG_STATE_OK, new Date(datestr));
        flock_blogDeletePost(this.selectedPost);
        flock_blogPublishClose(true);
    },

    onFault: function (fault) {
        //alert('Sorry, there was a problem posting to your blog:\n' + fault.faultString);
        //alert("Oops!  We couldn't publish your blog post becausethere is no valid website at that address");
        alert("Oops!  There was an error posting to your blog.  Please double check your account settings, or try again later");
        flock_blogPublishClose(false);
    },

    onError: function (errorMsg) {
        alert("Oops!  We couldn't publish your blog post becausethere is no valid website at that address");
        flock_blogPublishClose(false);
    }
};

function BlogEditListener(selectedPost) {
    this.selectedPost = selectedPost;
}

BlogEditListener.prototype = 
{
    selectedPost: null,
    onResult: function(result) 
    {
        if(result)
        {
            var ds = flock_blogGetDS();
            var post = ds.getNode(this.selectedPost);
            flock_blogSavePostState(post,BLOG_STATE_OK);
            ds.save();
            window.setTimeout("window.close();",0);
        }
        else
        {
            alert("ERROR CONDITION");
        }
        flock_blogPublishClose(true);
     },

     onFault: function (fault) 
     {
        //alert('Sorry, there was an error posting to your blog:\n' + fault.faultString);
        alert("Oops!  There was an error posting to your blog.  Please double check your account settings, or try again later");
        flock_blogPublishClose(false);
     },

     onError: function (errorMsg) 
     {
        alert("Oops!  We couldn't publish your blog post becausethere is no valid website at that address");
        flock_blogPublishClose(false);
     }
};
