//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

/*
 * The drag and drop observer for the groups
 */
var DNDObserver = function () {}
DNDObserver.prototype = {
	// Called if this item is dragged
	// ondraggesture = nsDragAndDrop.startDrag(event,DNDObserver)
	onDragStart: function (aEvent, aXferData, aDragAction) {
		// For elements we'll probably use this to reorder them
	},

	// Called when something is dragged into the item
	// ondragenter = nsDragAndDrop.dragEnter(event,DNDObserver)
	onDragEnter: function (aEvent, aDragSession) {
		// Use this to set canDrop if the dragged item is useful
		
	},

	// Called when something is dragged over the item
	// ondragover = nsDragAndDrop.dragOver(event,DNDObserver)
	onDragOver: function (aEvent, aFlavour, aDragSession) {
		// Use this to change the look of the element when an item
		// is being dragged over it
	},
	
	// Called when an object has been dragged out from over the item
	// ondragexit = nsDragAndDrop.dragExit((event,DNDObserver)
	onDragExit: function (aEvent, aDragSession) {
		// Use this to return the look of the element to its original
	},

	// Called when an item is dropped on the item
	// ondragdrop = nsDragAndDrop.drop(event, DNDObserver)
	onDrop: function (aEvent, aXferData, aDragSession) {
		// Use this to handle things that are dropped on this
	},

	// Called to get the flavours that this item accepts
	getSupportedFlavours: function () {
		// var flavourSet = new FlavourSet();
		// flavourSet.appendFlavour("text/x-moz-url");
		// return flavourSet;						   
	}
}
