//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

//const FLOCK_GROUP_URN = "urn:flock:topbar:groups";
const FLOCK_BREADCRUMBS_URN = "urn:flock:breadcrumbs";
const FLOCK_GROUPS_URN = "urn:flock:groups";
const FLOCK_NS = "http://www.flock.com/rdf#";
const FLOCK_DEBUG = 1;
//const FLOCK_WEB = "http://dev.roundtwo.com";
const FLOCK_WEB = "http://beta.flock.com";
const FLOCK_FEEDBACK_URL = FLOCK_WEB+"/feedback";
const FLOCK_BREADCRUMBS_URL = FLOCK_WEB+"/breadcrumbs";
const FLOCK_API = FLOCK_WEB+"/api";

const MARK_SELECTION_START = '\u200B\u200B\u200B\u200B\u200B';
const MARK_SELECTION_END = '\u200C\u200C\u200C\u200C\u200C';
const NS_XHTML = 'http://www.w3.org/1999/xhtml';

// nsIWebProgressListener constants
const STATE_IS_NETWORK = 
		Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK;
const STATE_STOP = 
		Components.interfaces.nsIWebProgressListener.STATE_STOP;

// nsIDOMNode constants
const TEXT_NODE = Components.interfaces.nsIDOMNode.TEXT_NODE;
const CDATA_SECTION_NODE = Components.interfaces.nsIDOMNode.CDATA_SECTION_NODE;
const ELEMENT_NODE = Components.interfaces.nsIDOMNode.ELEMENT_NODE;
	

const validUrlRegex = new RegExp ("^(https?|file)://");

function XXX() {
	var out = ''
	if (arguments.length > 1) {
		for (var i = 0;i < arguments.length;i++) {
			out += arguments[i] + " : ";
		}
	} else {
		out = "DEBUG : "+arguments[0];
	}
	if (FLOCK_DEBUG) dump(out+"\n");
}

// An introspection function
function dd(obj) {
	for (p in obj) {
		try {
			dump(p + ' :: ' + obj[p] + '\n'); 
			if (typeof obj[p] == 'object') { 
				for (q in obj[p]) { 
					dump(p + '.' + q + ' :: ' + obj[p][q] + '\n'); 
				} 
			}
		} catch(e) {
			continue;
		}
	}
}

function _ns(aAnchor) {
	return FLOCK_NS + aAnchor;
}

function flock_notifyUser(aMsg) {
	alert(aMsg);
}

function flock_mostRecentNavigator() {
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("navigator:browser");
    return topWindow;
}

function flock_goto(aUrl) {
	XXX("Sending user to url",aUrl);
	//window.parent.loadURI(aUrl);
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("navigator:browser");
	topWindow.content.location = aUrl;

	//top.content.location = aUrl;
}

function flock_gotoTab(aUrl) {
	XXX("Sending user to url in new tab",aUrl);
	//window.parent.loadURI(aUrl);
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("navigator:browser");
	var browser = topWindow.getElementById('content');
	
	browser.loadOneTab(aUrl, null, null, null, false);

}

function flock_escape(aStr){
	txt='';
	for (i=0; i < aStr.length; i++) {
		if (aStr.charCodeAt(i) < 127) {
			txt += escape(aStr[i]);
		}
		else {
			txt += aStr[i];
		}
	}
	return txt;
}

function $(aElementName) {
	return document.getElementById(aElementName);
}

function $$(aElementName) {
	return top.document.getElementById(aElementName);
}


function flock_clearChildren(aParent) {
	var childrenLength = aParent.childNodes.length;
	for (var i = 0; i < childrenLength; i++) {
		aParent.removeChild(aParent.childNodes[0]);
	}
}

function flock_limitPopupChildren(aTarget, aLimit) {
	for (var i = 0; i < aLimit; i++) {
		if (aTarget.childNodes[i]) {
			aTarget.childNodes[i].removeAttribute("collapsed");
			aTarget.childNodes[i].removeAttribute("hidden");
		}
	}
}

function flock_cleanupRemovedChildren() {
	XXX('CLEANING UP REMOVED CHILDREN');
	var elements = document.getElementsByAttribute("removechildren","true");
	for (var i = 0; i < elements.length; ++i) {
	   flock_clearChildren(elements[i]);
	}
}

window.addEventListener('load',flock_cleanupRemovedChildren,false);


function flock_reorderPopupChildren(aTarget) {
	for (var i = 1; i < arguments.length; i++) {
		aTarget.appendChild($(arguments[i]));
	}
	//target.appendChild($('flock_plusButtonMenuCollectionsSeparator'));
	//target.appendChild($('flock_plusButtonMenuCollectionsNew'));
}


function _write_file(str_Buffer,str_Filename){
	dump('Got to _write_file: ' + str_Filename + '\n');
	try{
		var obj_File = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		obj_File.initWithPath(str_Filename);
		if(!obj_File.exists())
			obj_File.create(0x00,0644);
	}
	catch(e){
		alert(e);
	}
	try {
		var obj_Transport = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		obj_Transport.init( obj_File, 0x04 | 0x08 | 0x10, 064, 0 );
		obj_Transport.write(str_Buffer,str_Buffer.length);
		obj_Transport.close();
	}
	catch(e){
		alert(e);
	}
}

function flock_scrollLeft(aScrollbox,aScrollBy) {
	var x = {};
	var y = {};
	aScrollbox.getPosition(x, y);
	flock_scrollTo(aScrollbox,x.value - aScrollBy, y.value);
}

function flock_scrollRight(aScrollbox,aScrollBy) {
	var x = {};
	var y = {};
	aScrollbox.getPosition(x, y);
	flock_scrollTo(aScrollbox,x.value + aScrollBy, y.value);
}

function flock_scrollTo(aScrollbox,aPosX,aPosY) {
	XXX("SCROLLING TO", aPosX, aPosY);
	aScrollbox.scrollTo(aPosX, aPosY);
}

function flock_getCurrentUrl() {
//	var curUrl = $("urlbar").value;
	var curUrl = gBrowser.mCurrentBrowser.currentURI.spec;
	XXX("CURURL",curUrl);
	return curUrl;
}

function flock_getCurrentTitle() {
	var title =  $('content').contentTitle;
	if (title.length < 1) {
		title = "Untitled";
	}
	return title;
}

function flock_getCurrentFeeds() {
	var curFeeds = gBrowser.selectedBrowser.feeds;
	return curFeeds;
}

function flock_getCurrentFeedsArray() {
	var curFeeds = flock_getCurrentFeeds();
	if (curFeeds) {
		var outArr = new Array();
		for (var i = 0; i < curFeeds.length; ++i) {
			outArr.push(curFeeds[i].href);  
		}
		return outArr;
	}
	return;
}

function flock_gotoAgg(aFeeds, aReturnURL) {/*{{{*/
	var outArr = new Array();
	for (var i = 0;i < aFeeds.length;i++) {
		outArr.push("li" + i + "=" + escape(aFeeds[i]));
	}
	flock_goto("chrome://browser/content/flock/rss/aggview.xul?"+outArr.join("&"));   
}/*}}}*/



function flock_getPrefService(branch) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
//	XXX("PREFS SERVICE",prefs);
//	XXX("PREFS ROOT",prefs.root);
//	if (branch) {
//		prefs = prefs.getBranch(branch);
//		XXX("PREFS BRANCH",prefs);
//		XXX("PREFS BRANCH ROOT",prefs.root);
//	}
	return prefs
}

function flock_getPref(aKey) {
	var prefService = flock_getPrefService();
	try {
		return prefService.getCharPref("flock."+aKey);
	} catch (e) {
		return "";
	}
}

function flock_setPref(aKey,aValue) {
	XXX("SET PREF",aKey,aValue);
	var prefService = flock_getPrefService();
	prefService.setCharPref("flock."+aKey,aValue);
}

function flock_clearPref(aKey) {
	var prefService = flock_getPrefService();
	prefService.clearUserPref("flock."+aKey);
	prefService.deleteBranch("flock."+aKey);
}

function flock_setIntPref(aKey,aValue) {
	XXX("SET PREF",aKey,aValue);
	var prefService = flock_getPrefService();
	prefService.setIntPref("flock."+aKey,aValue);
}

function flock_getIntPref(aKey) {
	var prefService = flock_getPrefService();
	try {
		return prefService.getIntPref("flock."+aKey);
	} catch (e) {
		return "";
	}
}

function flock_setBoolPref(aKey,aValue) {
	XXX("SET PREF",aKey,aValue);
	var prefService = flock_getPrefService();
	prefService.setBoolPref("flock."+aKey,aValue);
}

function flock_getBoolPref(aKey) {
	var prefService = flock_getPrefService();
	try {
		return prefService.getBoolPref("flock."+aKey);
	} catch (e) {
		return "";
	}
}

function flock_getFlagService() {
	return flock_getPrefService('flock.flags');
}


//var gFlockFlags = new Array();

function flock_setFlag(aKey,aValue) {
	XXX("SET FLAG",aKey,aValue);
	var flagService = flock_getFlagService();
	flagService.setBoolPref("flock.flags."+aKey,aValue);
//	gFlockFlags[aKey] = aValue;
//	var flagObserver = flock_getFlagObserver();
//	return flagObserver.setFlag(aKey,aValue);
}


function flock_getFlag(aKey) {
	var flagService = flock_getFlagService();
	try {
		return flagService.getBoolPref("flock.flags."+aKey);
	} catch (e) {
		return false;
	}
//	if (gFlockFlags[aKey]) {
//		return true;
//	} else {
//		return false;
//	}
//	var flagObserver = flock_getFlagObserver();
//	return flagObserver.getFlag(aKey);
}

//function flock_getFlagObserver() {
//	var observerService = flock_getObserverService();
//	var flagObserverEnum = observerService.enumerateObservers("flock-flags");
//	var flagObserver;
//	if (flagObserverEnum.hasMoreElements()) {
//		flagObserver = flagObserverEnum.getNext();
//	} else {
//		flagObserver = flock_registerFlagObserver();
//	}
//	XXX("FLAG OBSERVER",flagObserver);
//	return flagObserver;
//}

function flock_getObserverService() {
	return Components.classes["@mozilla.org/observer-service;1"]
		.getService(Components.interfaces.nsIObserverService);
}

//function flock_registerFlagObserver() {
//	var observerService = flock_getObserverService();
//	var flagObserver = {
//		observe: function (aSubject, aTopic, aData) {},
//		setFlag: function (aKey, aValue) {
//			this.data[aKey] = aValue;
//			XXX("SETFLAG",aKey,aValue);
//		},
//		getFlag: function (aKey) {
//			if (this.data[aKey]) {
//				return true;
//			} else {
//				return false;
//			}
//		},
//		data: new Array()
//	}
//	observerService.addObserver(flagObserver,"flock-flags",false);
//}

function flock_registerOfflineObserver() {
	var offlineObserver = function (aSubject, aTopic, aData) {
		if (aData == "online") {
			flock_setFlag("browser_online",true);
		} else {
			flock_setFlag("browser_online",false);
		}
	}
	flock_registerSimpleObserver("network:offline-status-changed",offlineObserver);
}

function flock_registerSimpleObserver(aTopic,aCallback) {
	var observer = {
		observe: aCallback
	}
	flock_getObserverService().addObserver(observer,aTopic,false);
}

function flock_getBookmarksService() {
	return flock_getRDFService().GetDataSource('rdf:flock-bookmarks').QueryInterface(Components.interfaces.flockIBookmarksService);
}

function flock_getFavoritesService() {
	return flock_getRDFService().GetDataSource('rdf:flock-favorites').QueryInterface(Components.interfaces.flockIFavoritesService);
}

function flock_getFavoritesDataSource() {
    return flock_getRDFService().GetDataSource('rdf:flock-favorites');
}
function flock_getHistoryDataSource() {
    return flock_getRDFService().GetDataSource('rdf:history');
}

function flock_clearDataSources(aElement) {
    var sources = aElement.database.GetDataSources();
    while (sources.hasMoreElements()) {
        var source = sources.getNext();
        aElement.database.RemoveDataSource(source);
    }
}

function flock_setDataSources(aElement) {
    flock_clearDataSources(aElement);
    for (var i = 1; i < arguments.length; ++i) {
        XXX(arguments[i]);
        aElement.database.AddDataSource(arguments[i]);
    }
}

function flock_getRDFService() {
	var nsIRDFService = Components.interfaces.nsIRDFService;
	var RDFSERVICE_CONTRACTID = '@mozilla.org/rdf/rdf-service;1';
	return Components.classes[RDFSERVICE_CONTRACTID].getService(nsIRDFService);
}

function flock_getResource(aStr) {
	return flock_getRDFService().GetResource(aStr);
}

function flock_getDragService() {
	var nsIDragService = Components.interfaces.nsIDragService;
	var DRAGSERVICE_CONTRACTID = '@mozilla.org/widget/dragservice;1';
	return Components.classes[DRAGSERVICE_CONTRACTID].getService(nsIDragService);
}

function flock_getRSSService() {
	var flockIRSSService = Components.interfaces.flockIRSSService;
	var RSSSERVICE_CONTRACTID = '@flock.com/rssservice;1';
	return Components.classes[RSSSERVICE_CONTRACTID].getService(flockIRSSService);
}
function flock_getFeedService() {
	var flockIRSSService = Components.interfaces.flockIRSSService;
	var RSSSERVICE_CONTRACTID = '@flock.com/rssservice;1';
	return Components.classes[RSSSERVICE_CONTRACTID].getService(flockIRSSService);
}
function flock_setStatusBar(aMsg) {
	if (!aMsg) aMsg = "";
	$('statusbar-display').setAttribute('label',aMsg);
	setTimeout("flock_setStatusBar()",10000);
}


function flock_ensureRDF(aURN, aFileName) {
	try {
		//Simple rdf.
		var rdf='<?xml version="1.0"?>' +
			'<RDF:RDF xmlns:NS1="http://www.flock.com/rdf#"' +
			'	   xmlns:RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#">' +
			'  <RDF:Seq about="'+aURN+'">' +
			'  </RDF:Seq>' +
			'</RDF:RDF>';

		//Create file object in the user's profile path.
		var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
		var profileDir = dirService.get('ProfD', Components.interfaces.nsILocalFile);
		var fileObj = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		fileObj.initWithPath(profileDir.path);
		fileObj.append(aFileName);

		//If it doesn't exist, write it.
		if (!fileObj.exists()) {
			_write_file(rdf, fileObj.path);
		}
		return fileObj;
	} catch (e) {
		XXX("ERROR", e);
	}
}


function flock_escapeHTML (aString) {
	var div = document.createElement('div');
	var text = document.createTextNode(aString);
	div.appendChild(text);
	return div.innerHTML;
}
//function flock_firstTimeNag() {
//	return;
//	if (!flock_getFlag("already_nagged") && flock_getCurrentUrl() == "http://flock.com/welcome/") {
//		flock_setFlag("already_nagged",true);
//		firstTimeNag = confirm("This browser is pretty hot out of the oven and is currently very tightly integrated with the Flock web service. If you are not signed in many things may not work as expected. Future releases will have a capable offline mode, but we were so excited to let you all check out what we're working on that we wanted to give it to you a bit early. To be taken to the sign in and registration page right now, please click OK and once you have signed in a cookie should be set and you will not have to sign in again (very often).");
//		if (firstTimeNag) {
//			XXX("Sending user to login page");
//			flock_goto(FLOCK_WEB+"/user/signup");
//		}
//	}
//}

//if (!flock_getFlag("already_nagged")) {
//	window.addEventListener("load",flock_firstTimeNag, true);
//}

function flock_PageQuery(q) {
	if(q.length > 1) this.q = q.substring(1, q.length);
	else this.q = null;

	this.keyValuePairs = new Array();

	if(q) {
		for(var i=0; i < this.q.split("&").length; i++) {
			this.keyValuePairs[i] = this.q.split("&")[i];
		}
	}
	this.getKeyValuePairs = function() { return this.keyValuePairs; }
	this.getValue = function(s) {
		for(var j=0; j < this.keyValuePairs.length; j++) {
			if(this.keyValuePairs[j].split("=")[0] == s)
			return unescape(this.keyValuePairs[j].split("=")[1]);
		}
		return false;
	}
	this.getParameters = function() {
		var a = new Array(this.getLength());
		for(var j=0; j < this.keyValuePairs.length; j++) {
			a[j] = this.keyValuePairs[j].split("=")[0];
		}
		return a;
	}

	this.getValues = function() {
		var a = new Array(this.getLength());
		for(var j=0; j < this.keyValuePairs.length; j++) {
			a[j] = unescape(this.keyValuePairs[j].split("=")[1]);
		}
		return a;
	}
	this.getLength = function() { return this.keyValuePairs.length; }
}


function flock_getMarkedUpSelection(aEvt, aDropData, aSession){
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("navigator:browser");

	var data="";
	var node=aSession.sourceNode;
	var serializer = new XMLSerializer();
	var parser = new DOMParser();

	var header="Header";
	var label="Label";
	var type="document";

	//Not handling files just yet.
	if(aDropData.flavour.contentType=='application/x-moz-file'){
		return null;
	}

	//For dragging from outside the browser. Not supported for now.
	if(!node){
		return null;
	}

	//Handle image maps
	if(node.nodeName.toLowerCase()=='area'){
		var map='#' + node.parentNode.getAttribute('name');
		var images=topWindow.window._content.document.getElementsByTagName('img');
		dump(images.length + '\n');
		for(i=0; i<images.length; i++){
			dump('IMG: ' + images[i].src + '\n');
			if(images[i].getAttribute('usemap')==map){
				node=images[i];
			}
		}
		if(node.nodeName.toLowerCase()=='area'){
			dump('Could not find image corresponding to map ' + map + '.\n');
			return false;
		}
		//TODO: Normalize paths for node...
		return { type: type, header: header, label: label, src: serializer.serializeToString(node) };
	}

	//Big hack. This is for when somebody drags the favicon onto the shelf. Without this, we get the xul source b/c we're using sourceNode.
	if(node.nodeName.toLowerCase()=='image'){
		header=topWindow.document.getElementById('content').contentTitle;
		label=aDropData.data;
		type='link';
		var src='<a href="' + aDropData.data + '">' + $$('content').contentTitle + '</a>';
		return { type: type, header: header, label: label, src: src };
	}

	//Handle flickr photos
	if(node.nodeName.toLowerCase()=='flickrphoto'){
		var doc = parser.parseFromString(node.photoHTML, "text/xml");
		img_elm=doc.getElementsByTagName('img');
		a_elm=doc.getElementsByTagName('a');
		header=img_elm[0].getAttribute('alt');
		label=a_elm[0].getAttribute('href');
		type="image";
		return { type: 'image', header: header, label: label, src: node.photoHTML };
	}

	//Handle selections	
	var selection = topWindow.document.getElementById('content').mCurrentBrowser.contentWindow.getSelection(); 
	if(selection.toString().length > 0){
		var selection_formatted=select_src(selection);
		title=topWindow.document.getElementById('content').contentTitle;
		if(title.length==0) title = location;

		var location = topWindow.document.getElementById('content').mCurrentBrowser.contentWindow.location + "";
		if(location.match(/^chrome:\/\/.+/)){
			location = "";
		}

		//TODO: Normalize paths for selection...
		data = '<blockquote cite="' + location + '">' + selection_formatted.html + "</blockquote>";
		data += '<p class="citation"><cite cite="' + location + '"><a href="' + location + '">' + title + '</a>' + "</cite></p><br/>";
		header=location;
		label=selection;
		return { type: 'document', header: header, label: label, src: data };
	}

	else{
		if(node.nodeName.toString().toLowerCase()=='#text'){
			node=node.parentNode;
		}

		//If it's an img, make sure the src attribute is the full path
		if(node.src){
			node.setAttribute('src',node.src);
			type='image';
			label=node.src;
			header=node.src;
			if(node.getAttribute('alt')){
				header=node.getAttribute('alt');
			}
		}
		//If it's a link make sure the href attribute is the full path
		if(node.href){
			node.setAttribute('href',node.href);
			type='link';
			label=node.href;
			header=node.textContent;
		}
		return { type: type, header: header, label: label, src: serializer.serializeToString(node) };
	}

	return aDropData.data;

}

function flock_favoriteSharingPrompt() {
	var prefService = flock_getPrefService ();
	var asked_already = false;
	try {
		asked_already = prefService.getBoolPref ('flock.favorites.askedAboutSharing');
	} catch (e) { }

	if (!asked_already) {
		window.openDialog ('chrome://browser/content/flock/favorites/favoritesSharing.xul', 'favorites-sharing', 'chrome,modal,centerscreen');
	}
}

//Ok, this needs a whole lot of cleaning up. Ripped from viewPartialSource.js in global in core source and hacked a smidgin.
function select_src(selection){
	var range = selection.getRangeAt(0);
	var ancestorContainer = range.commonAncestorContainer;
	var doc = ancestorContainer.ownerDocument;

	var startContainer = range.startContainer;
	var endContainer = range.endContainer;
	var startOffset = range.startOffset;
	var endOffset = range.endOffset;

	// let the ancestor be an element
	if (ancestorContainer.nodeType == Node.TEXT_NODE ||
			ancestorContainer.nodeType == Node.CDATA_SECTION_NODE)
		ancestorContainer = ancestorContainer.parentNode;

	// for selectAll, let's use the entire document, including <html>...</html>
	// @see DocumentViewerImpl::SelectAll() for how selectAll is implemented
	try {
		if (ancestorContainer == doc.body)
			ancestorContainer = doc.documentElement;
	} catch (e) { }

	// each path is a "child sequence" (a.k.a. "tumbler") that
	// descends from the ancestor down to the boundary point
	var startPath = getPath(ancestorContainer, startContainer);
	var endPath = getPath(ancestorContainer, endContainer);

	// clone the fragment of interest and reset everything to be relative to it
	// note: it is with the clone that we operate from now on
	ancestorContainer = ancestorContainer.cloneNode(true);
	startContainer = ancestorContainer;
	endContainer = ancestorContainer;
	var i;
	for (i = startPath ? startPath.length-1 : -1; i >= 0; i--) {
		startContainer = startContainer.childNodes.item(startPath[i]);
	}
	for (i = endPath ? endPath.length-1 : -1; i >= 0; i--) {
		endContainer = endContainer.childNodes.item(endPath[i]);
	}

	// add special markers to record the extent of the selection
	// note: |startOffset| and |endOffset| are interpreted either as
	// offsets in the text data or as child indices (see the Range spec)
	// (here, munging the end point first to keep the start point safe...)
	var tmpNode;
	if (endContainer.nodeType == Node.TEXT_NODE ||
			endContainer.nodeType == Node.CDATA_SECTION_NODE) {
		// do some extra tweaks to try to avoid the view-source output to look like
		// ...<tag>]... or ...]</tag>... (where ']' marks the end of the selection).
		// To get a neat output, the idea here is to remap the end point from:
		// 1. ...<tag>]...	 to	 ...]<tag>...
		// 2. ...]</tag>...	to	 ...</tag>]...
		if ((endOffset > 0 && endOffset < endContainer.data.length) ||
				!endContainer.parentNode || !endContainer.parentNode.parentNode)
			endContainer.insertData(endOffset, MARK_SELECTION_END);
		else {
			tmpNode = doc.createTextNode(MARK_SELECTION_END);
			endContainer = endContainer.parentNode;
			if (endOffset == 0)
				endContainer.parentNode.insertBefore(tmpNode, endContainer);
			else
				endContainer.parentNode.insertBefore(tmpNode, endContainer.nextSibling);
		}
	}
	else {
		tmpNode = doc.createTextNode(MARK_SELECTION_END);
		endContainer.insertBefore(tmpNode, endContainer.childNodes.item(endOffset));
	}

	if (startContainer.nodeType == Node.TEXT_NODE ||
			startContainer.nodeType == Node.CDATA_SECTION_NODE) {
		// do some extra tweaks to try to avoid the view-source output to look like
		// ...<tag>[... or ...[</tag>... (where '[' marks the start of the selection).
		// To get a neat output, the idea here is to remap the start point from:
		// 1. ...<tag>[...	 to	 ...[<tag>...
		// 2. ...[</tag>...	to	 ...</tag>[...
		if ((startOffset > 0 && startOffset < startContainer.data.length) ||
				!startContainer.parentNode || !startContainer.parentNode.parentNode ||
				startContainer != startContainer.parentNode.lastChild)
			startContainer.insertData(startOffset, MARK_SELECTION_START);
		else {
			tmpNode = doc.createTextNode(MARK_SELECTION_START);
			startContainer = startContainer.parentNode;
			if (startOffset == 0)
				startContainer.parentNode.insertBefore(tmpNode, startContainer);
			else
				startContainer.parentNode.insertBefore(tmpNode, startContainer.nextSibling);
		}
	}
	else {
		tmpNode = doc.createTextNode(MARK_SELECTION_START);
		startContainer.insertBefore(tmpNode, startContainer.childNodes.item(startOffset));
	}


	// now extract and display the syntax highlighted source
	tmpNode = doc.createElementNS(NS_XHTML, 'div');
	tmpNode.appendChild(ancestorContainer);

	html=tmpNode.innerHTML;
	txt=tmpNode.textContent;
	var html_start=html.indexOf(MARK_SELECTION_START) + 5; //Because there are five characters in that const.
	var html_end=html.indexOf(MARK_SELECTION_END);
	html=html.substring(html_start,html_end);
	var txt_start=txt.indexOf(MARK_SELECTION_START) + 5; //Because there are five characters in that const.
	var txt_end=txt.indexOf(MARK_SELECTION_END);
	txt=txt.substring(txt_start,txt_end);
	//dump('START: ' + mystart + '\nEND: ' + myend + '\nVAL: --' + html + '--\n');
	dump('TXT: ' + txt + '\n');
	dump('HTML: ' + html + '\n');
	return { html: html, txt: txt };


dump('NODE: \n' + tmpNode.innerHTML + '\n');
}

//Also ripped from viewPartialSource.js. Probably a good idea to keep this here, in case it changes in the core source.
function getPath(ancestor, node)
{
	var n = node;
	var p = n.parentNode;
	if (n == ancestor || !p)
		return null;
	var path = new Array();
	if (!path)
		return null;
	do {
		for (var i = 0; i < p.childNodes.length; i++) {
			if (p.childNodes.item(i) == n) {
				path.push(i);
				break;
			}
		}
		n = p;
		p = n.parentNode;
	} while (n != ancestor && p);
	return path;
}


