//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

function jsxmlrpc_call()
{
    var listener = arguments[0];   
    var url = arguments[1];   
    var call = arguments[2];   

    var params = new Array();

    for(var i=3;i<arguments.length;++i)
    {
        params[params.length] = arguments[i];
    }
    var rpc = new JSXMLRPC();

    rpc.call(listener, url, call, params);
}

Object.prototype.toXMLRPCParam = function()
{
    var rval = "<struct>";
    for(p in this)
    {
        if(p.match(/toX/)) continue;
        var child = this[p].toXMLRPCParam();
        rval += "<member><name>" + p + "</name><value>" + child + "</value></member>";
    }
    rval += "</struct>";
    return rval;
}

String.prototype.toXMLRPCParam = function()
{ 
    var data = this.replace(/\]\]/g, "] ]");
    return "<string><![CDATA[" + data + "]]></string>";
}

Number.prototype.toXMLRPCParam = function()
{
    if(this == parseInt(this))
    {
        return "<int>" + this + "</int>";
    }
    else if(this == parseFloat(this))
    {
        return "<double>" + this + "</double>";
    }
    throw("Invalid Number Format");
}

Boolean.prototype.toXMLRPCParam = function()
{
    if(this==true) return "<boolean>1</boolean>";

    return "<boolean>0</boolean>";
}

Date.prototype.toXMLRPCParam = function()
{
    return "<dateTime.iso8601>" + iso8601Format(this) + "</dateTime.iso8601>";
}

Array.prototype.toXMLRPCParam = function()
{
    var rval = "<array><data>";
    for(var i=0;i<this.length;++i)
    {
        rval += "<value>" + this[i].toXMLRPCParam() + "</value>";
    }
    rval += "</array></data>";
}

function JSXMLRPC()
{
}

/*
 -- XML-RPC client -- : Request: <?xml version="1.0" ?><methodCall><methodName>m
 etaWeblog.getRecentPosts</methodName><params><param><value><string><![CDATA[]]><
 /string></value></param><param><value><string><![CDATA[anthony]]></string></valu
 e></param><param><value><string><![CDATA[password]]></string></value></param><pa
 ram><value><i4></i4></value></param></params></methodCall>
*/

JSXMLRPC.prototype = 
{
    INT:      1,
    BOOLEAN:  2,
    STRING:   3,
    DOUBLE:   4,
    DATETIME: 5,
    ARRAY:    6,
    STRUCT:   7,

    ERROR_HTTP:   10,
    ERROR_FAULT:   11,
    ERROR_PARSER:   12,

    _uri: null,
    _req: null,
    _listener: null,
    _error: false,

    call: function(listener, url, call, params)//arguments follow
    {
        this._listener = listener;
        var message = '<?xml version="1.0" ?>';
        message += '<methodCall><methodName>';
        message += call;
        message += '</methodName><params>';

        for(var i=0;i<params.length;++i)
        {
            var cur = params[i];
            message += "\n";
            message += '<param><value>';
            message += cur.toXMLRPCParam();
            message += '</value></param>';
            continue;
        }
        message += '</params></methodCall>';

        var inst = this;
        this._req = new XMLHttpRequest();
        this._req.open('POST', url, true);
        this._req.onreadystatechange = function (aEvt) 
        {
            if(inst._req.readyState == 4) 
            {
                if(inst._req.status == 200)
                {
                    dump("\n" + inst._req.responseText + "\n");
                    try
                    {
                        var result = inst.doParse();
                        //alert(result);
                        if(inst._error)
                        {
                            listener.onFault(result);
                        }
                        else
                        {
                            listener.onResult(result);
                        }
                    }
                    catch(e)
                    {
                        dump(e + "\n");
                        listener.onError(inst.ERROR_PARSER);
                    }
                }
                else
                {
                    listener.onError(inst._req.status);
                }
            }
        };
        //alert(message);
        dump("\n" + message + "\n");
        this._req.setRequestHeader("Content-Type", "text/xml");
        this._req.send(message); 
    },

    //TODO: GET RID OF THE NEXT FUNCTION
    /*
    asyncCall: function()//arguments follow
    {
        var listener = arguments[0];   
        this._listener = listener;
        var url = arguments[1];   
        var call = arguments[2];   

        var message = '<?xml version="1.0" ?>';
        message += '<methodCall><methodName>';
        message += call;
        message += '</methodName><params>';

        for(var i=3;i<arguments.length;++i)
        {
            var cur = arguments[i];
            message += '<param><value>';
            message += cur.toXMLRPCParam();
            message += '</value></param>';
            continue;
        }
        message += '</params></methodCall>';

        var inst = this;
        this._req = new XMLHttpRequest();
        this._req.open('POST', url, true);
        this._req.send(message); 
        this._req.onreadystatechange = function (aEvt) 
        {
            if(inst._req.readyState == 4) 
            {
                if(inst._req.status == 200)
                {
                    var result = inst.doParse();
                    listener.onResult(result);
                }
                else
                {
                    listener.onError(inst.ERROR_HTTP);
                }
            }
       };
    },
    */

    doError: function(error)
    {
        this._error = error;
        //this._listener.onError(error);
    },
    doParse: function(listener, call)//arguments follow
    {
        var dom  = this._req.responseXML;
        if(!dom)
        {
            var str = this._req.responseText;
            str = str.replace(/\n/g, "");
            str = str.replace(/\r/g, "");
            //dump(str);
            if(str.match(/.*?(<\?xml.+)/))
            {
                //alert(RegExp.$1);
                var parser = new DOMParser();
                dom = parser.parseFromString(RegExp.$1,"text/xml");
            }
        }
        if(!dom) throw "Invalid Response From Server";
	    var faults = dom.getElementsByTagName("fault");

        if(faults.length>0)
        {
            var fault = faults[0];
            var data = this.extractValue(fault);
            this.doError(this.ERROR_FAULT);
            return data;
        }

	    var params = dom.getElementsByTagName("param");
        if(params.length) return this.extractValue(params[0]);
    },

    extractValue: function(data)//arguments follow
    {
        var value = this.getGoodChild(data.childNodes);
        if(value.nodeName=="value")
        {
            var primitive = this.getGoodChild(value.childNodes);
            var rv;
            if(primitive)
            {
                rv = this.extractPrimitive(primitive);
            }
            else
            {
                rv = value.firstChild.nodeValue;
            }
            return rv;
        }

        return null;
    },

    extractPrimitive: function(data)//arguments follow
    {
        if(!data) return "";
//        if(data) alert(data.nodeName + " = " + data.nodeValue);
//        if(!data) alert("ARGHH" + data);
		switch(data.nodeName)
        {
            case "struct":
                {
                    var structObj = {};
                    var struct = data.childNodes;
                    for(var i=0;i<struct.length;++i)
                    {
                        var member = struct[i];
                        if(this.isGoodChild(member))
                        {
                            var member_children = member.childNodes;
                            var name = null;
                            var value = null;
                            for(var j=0;j<member_children.length;++j)
                            {
                                var member_child = member_children[j];
                                if(this.isGoodChild(member_child))
                                {
                                    if(member_child.nodeName=="name")
                                    {
                                        name = member_child.firstChild.nodeValue;
                                    }
                                    if(member_child.nodeName=="value")
                                    {
                                        if(member_child.firstChild)
                                        {
                                            valueNode = member_child.firstChild;
                                            value = this.extractPrimitive(valueNode);
                                            if(!value)
                                            {
                                                value = member_child.firstChild.nodeValue;
                                            }
                                        }
                                        else
                                        {
                                            value = "";
                                        }
                                    }
                                    if(name && value)
                                    {
                                       structObj[name] = value; 
                                    }
                                }
                            }
                        }
                    }
                    return structObj;
                }
            break;
            case "i4":
            case "int":
                {
                    return parseInt(data.firstChild.nodeValue);
                }
            break;
            case "boolean":
            {
                    return (parseInt(data.firstChild.nodeValue)==1);
            }
            case "#text":
            {
                var rval = "";
                var child = data;
                while(child)
                {
                    rval += child.nodeValue;
                    child = child.nextSibling;
                }
                return rval;
            }
            break;
            case "string":
                {
                    if(!data.firstChild)
                    {
                        return "";
                    }

                    var rval = "";
                    var child = data.firstChild;
                    while(child)
                    {
                        rval += child.nodeValue;
                        child = child.nextSibling;
                    }

                    return rval;
                }
            break;
			case "dateTime.iso8601":
                {
                    dump("date\n");
                    var val = data.firstChild.nodeValue + "";
                    var dateutc =  Date.UTC(val.slice(0, 4), val.slice(4, 6) - 1, val.slice(6, 8), val.slice(9, 11), val.slice(12, 14), val.slice(15));
                    var date = new Date(dateutc);
                    return date;
                }
            break;
			case "array":
                {
                    var rv = new Array();
                    var data_tag = this.getGoodChild(data.childNodes);
                    for (var i=0;i<data_tag.childNodes.length;++i)
                    {
                        var node = data_tag.childNodes[i];
                        if(this.isGoodChild(node))
                        {
                            var primitive = this.getGoodChild(node.childNodes);
                            rv[rv.length] = this.extractPrimitive(primitive);
                        }
                    }
                    return rv;
                }
            break;
            default:
                //alert("SHIOT");
            break;
        }
        return null;
    },

    isGoodChild: function(node)
    {
        if(!node.nodeName) return false;
        if(node.nodeName.match(/text/)) return false;
        return true;
    },

    getGoodChild: function(children)
    {
        for(var i=0;i<children.length;++i)
        {
            if(this.isGoodChild(children[i])) return children[i];
        }
        return null;
    }

}

function Value()
{
}

Value.prototype = 
{
    INT:      JSXMLRPC.prototype.INT,
    BOOLEAN:  JSXMLRPC.prototype.BOOLEAN,
    STRING:   JSXMLRPC.prototype.STRING,
    DOUBLE:   JSXMLRPC.prototype.DOUBLE,
    DATETIME: JSXMLRPC.prototype.DATETIME,
    ARRAY:    JSXMLRPC.prototype.ARRAY,
    STRUCT:   JSXMLRPC.prototype.STRUCT,
    data:   "",
    toXML:   function()
    {
    },
    toXML:   function()
    {
    },
}

function iso8601Format(date) 
{
    var datetime = date.getUTCFullYear();
    var month = String(date.getUTCMonth() + 1);
    datetime += (month.length == 1 ?  '0' + month : month);
    var day = date.getUTCDate();
    datetime += (day < 10 ? '0' + day : day);

    datetime += 'T';

    var hour = date.getUTCHours();
    datetime += (hour < 10 ? '0' + hour : hour) + ':';
    var minutes = date.getUTCMinutes();
    datetime += (minutes < 10 ? '0' + minutes : minutes) + ':';
    var seconds = date.getUTCSeconds();
    datetime += (seconds < 10 ? '0' + seconds : seconds);

    return datetime;
}
