//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

// vim: foldmethod=marker
function flock_init() {/*{{{*/
    var flockFavorites = flock_getFavoritesService();
    var RDFS = flock_getRDFService();
    var folder = RDFS.GetResource(window.arguments[0]);

    var nameRDFNode = flockFavorites.GetTarget(
        folder,
        RDFS.GetResource("http://home.netscape.com/NC-rdf#Name"),
        true
    );

    var nameRDFLiteral = nameRDFNode.QueryInterface(Components.interfaces.nsIRDFLiteral);
    var name = nameRDFLiteral.Value;
    
    var nameNode = $('name');
    nameNode.value = name;
    document.title = document.title.replace(/\*\*collection_title\*\*/gi, name);

    // set initial focus
    nameNode.focus();
    nameNode.select();
}/*}}}*/

function flock_commit() {/*{{{*/
    var flockFavorites = flock_getFavoritesService();
    var RDFS = flock_getRDFService();
    var collection = RDFS.GetResource(window.arguments[0]);
    var props = Components.interfaces.flockIFavoriteProperties;
    flockFavorites.updateCollection(
        collection, 
        {   name: $('name').value, 
            fields: props.FIELD_NAME
        }
    );
    window.close();
    return true;
}/*}}}*/
