//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

// vim: foldmethod=marker
function getLiteral(aSource, aPredicate) {/*{{{*/
    var flockFavorites = flock_getFavoritesService();
    var RDFS = flock_getRDFService();
    var RDFNode = flockFavorites.GetTarget(
        aSource,
        RDFS.GetResource(aPredicate),
        true
    );
    if (!RDFNode) {
        return "";
    }

    var RDFLiteral = RDFNode.QueryInterface(Components.interfaces.nsIRDFLiteral);
    if (!RDFLiteral) {
        return "";
    }
    return RDFLiteral.Value;
}/*}}}*/

function flock_init() {/*{{{*/
    var RDFS = flock_getRDFService();
    var favorite = RDFS.GetResource(window.arguments[0]);

    var name = getLiteral(favorite, "http://home.netscape.com/NC-rdf#Name");
    var desc = getLiteral(favorite, "http://home.netscape.com/NC-rdf#Description");
    var count = {};
    var tags = flock_getFavoritesService().getTagsField(favorite.Value);

    var url = window.arguments[0];
    
    var nameNode = $('name');
    nameNode.value = name;
    document.title = document.title.replace(/\*\*favorite_title\*\*/gi, name);
    
    $('description').value = desc;
    $('url').value = url;    
    $('tags').loadString(tags);

    // set initial focus
    nameNode.focus();
    nameNode.select();
}/*}}}*/

function flock_commit() {/*{{{*/
    var flockFavorites = flock_getFavoritesService();
    var RDFS = flock_getRDFService();
    var favorite = RDFS.GetResource(window.arguments[0]);
    var props = Components.interfaces.flockIFavoriteProperties;
    var url = $('url').value;
    var pillTags = $('tags').toString();

    flockFavorites.updateFavorite(
        window.arguments[0], 
        {   name: $('name').value, 
            URL: url,
            tags: pillTags,
            description: $('description').value,
            fields: props.FIELD_NAME|props.FIELD_TAGS|props.FIELD_URL|props.FIELD_DESCRIPTION
        }
    );

    window.close();
    return true;
}/*}}}*/
