//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

// vim: foldmethod=marker


// These fools need to be refactored into something that can be reused
function flock_getXferDataFromSelection (aSelection) {/*{{{*/
    if (aSelection.count == 0)
        return null;
    var tree = aSelection.tree;
    var dataSet = new TransferDataSet();
    var data, item, itemUrl, itemName, parent, name;
    
    var rangeMin = {};
    var rangeMax = {};

    aSelection.getRangeAt(0, rangeMin, rangeMax);
    
    XXX('MINMAX', rangeMin.value, rangeMax.value);
    var anyData = false;    

    for (var i = rangeMin.value; i <= rangeMax.value; i++) {
        XXX('ON ITEM', i);
        // Skip feeds
        if (tree.view.getParentIndex(i) != -1) {
            XXX('SKIPPING FEED AT', i);
            continue;
        }

        data     = new TransferData();

        //item     = aSelection.item[i].Value;
        //itemUrl  = flock_getProperty(item, "http://home.netscape.com/NC-rdf#URL");
        //itemName = flock_getProperty(item, "http://home.netscape.com/NC-rdf#Name");
        //item = tree.view.getResourceAtIndex(i);
        itemUrl = flock_getCellText(aSelection.tree, i, "URL");
        itemName = flock_getCellText(aSelection.tree, i, "Name");
        //parent   = aSelection.parent[i].Value;
        //data.addDataForFlavour("moz/rdfitem",    item+"\n"+(parent?parent:""));
        //data.addDataForFlavour("moz/rdfitem",    item);
        data.addDataForFlavour("text/x-moz-url", itemUrl+"\n"+itemName);
        data.addDataForFlavour("text/html",      "<a href='"+itemUrl+"'>"+itemName+"</a>");
        data.addDataForFlavour("text/unicode",   itemUrl);
        dataSet.push(data);
        anyData = true;
    }
    if (!anyData) {
        return;
    }
    return dataSet;
}/*}}}*/
function flock_getDataFromDragSession (aDragSession) {/*{{{*/
    var trans = Components.classes['@mozilla.org/widget/transferable;1'].createInstance(Components.interfaces.nsITransferable);
    //trans.addDataFlavor("moz/rdfitem");
    trans.addDataFlavor("text/x-moz-url");
    trans.addDataFlavor("text/unicode");
    var uri, title;
    
    var arr = [];

    for (var i = 0; i < aDragSession.numDropItems; ++i) {
        var bestFlavour = {};
        var dataObj = {};
        var len = {};
        aDragSession.getData(trans, i);
        trans.getAnyTransferData(bestFlavour, dataObj, len);
        dataObj = dataObj.value.QueryInterface(Components.interfaces.nsISupportsString);
        if (!dataObj) {
            continue;
        }
        dataObj = dataObj.data.substr(0, len.value).split("\n");
        uri = dataObj[0];
        if (dataObj.length > 1 && dataObj[1] != "") {
            title = dataObj[1];
        } else {
            title = uri;
        }
        arr.push({uri: uri, title: title});
    }
    return arr;
}/*}}}*/
function flock_getProperty (aInput, aArcURI, aDS) {/*{{{*/
    var node;
    var RDF = flock_getRDFService();
    var arc  = RDF.GetResource(aArcURI);
    if (typeof(aInput) == "string") {
        aInput = RDF.GetResource(aInput);
    }
    if (!aDS) {
        node = flock_getFavoritesService().GetTarget(aInput, arc, true);
    } 
    else {
        node = aDS .GetTarget(aInput, arc, true);
    }
    try {
        return node.QueryInterface(Components.interfaces.nsIRDFResource).Value;
    }
    catch (e) {
        return node ? node.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : "";
    }    
}/*}}}*/
function flock_getCellText(aTree, aRow, aColName) {/*{{{*/
    // Quick hack to allow this to grab from favorites OR history
    var col = aTree.columns.getNamedColumn(aColName) || aTree.columns.getNamedColumn("h_" + aColName);
    return aTree.view.getCellText(aRow, col);
}/*}}}*/
function flock_gotoAgg(aFeeds) {/*{{{*/
    var outArr = new Array();
    for (var i = 0;i < aFeeds.length;i++) {
        outArr.push("li" + i + "=" + escape(aFeeds[i]));
    }
    flock_goto("chrome://browser/content/flock/rss/aggview.xul?"+outArr.join("&"));   
}/*}}}*/
function flock_isFeed(aRsrc) {/*{{{*/
    // test whether it is a feed
    if (flock_getProperty(aRsrc, "http://home.netscape.com/NC-rdf#FeedURL")) {
        return true;
    }
    return false;
}/*}}}*/



// Updates the view in the favoriteView pane to show the contents of 
// the selected collection
function flock_updateFavoriteView(aSelectedItem) {/*{{{*/
    if (!aSelectedItem) return;
    if (aSelectedItem.getAttribute('collection').indexOf("History") != -1) {
        flock_updateHistoryView(aSelectedItem);
        return;
    }
    $("flock_favoriteView").setAttribute('ref',aSelectedItem.getAttribute('collection'));
    $("flock_historyView").view.selection.clearSelection();
    $('flock_mainView').selectedPanel = $('flock_favoritePanel');
}/*}}}*/
function flock_updateHistoryView(aSelectedItem) {/*{{{*/
    if (!aSelectedItem) return;
    $("flock_historyView").setAttribute('ref',aSelectedItem.getAttribute('collection'));
    $("flock_favoriteView").view.selection.clearSelection();
    $('flock_mainView').selectedPanel = $('flock_historyPanel');
}/*}}}*/


function flock_switchSideToCollection() {/*{{{*/
    $('flock_managerTabCollections').setAttribute('selected','true');
    $('flock_managerTabTags').removeAttribute('selected');
    $('flock_sideView').selectedPanel = $('flock_collectionPanel');
    flock_updateFavoriteView($('flock_collectionLibrary'));

}/*}}}*/
function flock_switchSideToTag() {/*{{{*/
    $('flock_managerTabTags').setAttribute('selected','true');
    $('flock_managerTabCollections').removeAttribute('selected');
    $('flock_sideView').selectedPanel = $('flock_tagPanel');
    flock_updateFavoriteView($('flock_tagAll'));

}/*}}}*/


// Drag and drop handlers
// dnd handler for collections list /*{{{*/
var flock_collectionDNDObserver = new DNDObserver();
flock_collectionDNDObserver.onDragOver = function (aEvent, aFlavour, aDragSession) {
    aDragSession.dragAction = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY;
    var dropTarget = this.getDropItem(aEvent.target);
    if (!dropTarget || 
        (dropTarget.getAttribute('editable') != "true" 
         && dropTarget.getAttribute('dropable') != 'true')) {
        return;
    }
    dropTarget.setAttribute("dragOver","true");
    dropTarget.setAttribute("allowevents","false");
    return true;
}
flock_collectionDNDObserver.onDragExit = function (aEvent, aDragSession) {
    var dropTarget = this.getDropItem(aEvent.target);
    if (dropTarget.nodeName != "listitem") {
        return;
    }
    dropTarget.removeAttribute("dragOver");
    // XXX termie: Aaaaarrggh!!
    dropTarget.setAttribute("allowevents","true");
  
}
flock_collectionDNDObserver.getDropItem = function (aTarget) {
    var dropTarget = aTarget;
 
    if (dropTarget.nodeName == "listbox") {
        return;
    } else {
        while (dropTarget && (dropTarget.nodeName != "listitem")) {
            dropTarget = dropTarget.parentNode;
        }
    }
    return dropTarget;
}
flock_collectionDNDObserver.getDropBox = function (aTarget) {
    var dropTarget = aTarget;
    if (dropTarget.nodeName != "listbox") {
        while (dropTarget && (dropTarget.nodeName != "listbox")) {
            dropTarget = dropTarget.parentNode;
        }
    }
    return dropTarget;
}
flock_collectionDNDObserver.onDrop = function(aEvent, aXferData, aDragSession) {
    try {
    var flockFavorites = flock_getFavoritesService();
    var props = Components.interfaces.flockIFavoriteProperties;

    var dropTarget = this.getDropItem(aEvent.target);
    if (!dropTarget || 
        (dropTarget.getAttribute('editable') != "true" 
         && dropTarget.getAttribute('dropable') != 'true')) {
        return;
    }
    XXX("DROPPED ON LISTITEM", dropTarget.id);
    var droppedData = flock_getDataFromDragSession(aDragSession);
    for (var i = 0; i < droppedData.length; ++i) {
        var uri = droppedData[i]['uri'];
        var title = droppedData[i]['title'];
        flockFavorites.createFavorite(
            uri,
            {   name: title,
                fields: props.FIELD_NAME }
        );   
        flockFavorites.addFavoriteToCollection(uri,dropTarget.resource);
    }

    } catch (e) {
        dd(e)
    }
    return true;
}
flock_collectionDNDObserver.getSupportedFlavours = function () {
    var flavourSet = new FlavourSet();
    //flavourSet.appendFlavour("moz/rdfitem");
    flavourSet.appendFlavour("text/x-moz-url");
    flavourSet.appendFlavour("text/unicode");
    return flavourSet;
}/*}}}*/
// dnd handler for tags list /*{{{*/
var flock_tagDNDObserver = new DNDObserver();
flock_tagDNDObserver.onDragOver = function (aEvent, aFlavour, aDragSession) {
    aDragSession.dragAction = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY;
    var dropTarget = this.getDropItem(aEvent.target);
    if (!dropTarget || 
        (dropTarget.getAttribute('editable') != "true" 
         && dropTarget.getAttribute('dropable') != 'true')) {
        return;
    }
    dropTarget.setAttribute("dragOver","true");
    dropTarget.setAttribute("allowevents","false");
    return true;
}
flock_tagDNDObserver.onDragExit = function (aEvent, aDragSession) {
    var dropTarget = this.getDropItem(aEvent.target);
    if (dropTarget.nodeName != "richlistitem") {
        return;
    }
    dropTarget.removeAttribute("dragOver");
    // XXX termie: Aaaaarrggh!!
    dropTarget.setAttribute("allowevents","true");
  
}
flock_tagDNDObserver.getDropItem = function (aTarget) {
    var dropTarget = aTarget;
 
    if (dropTarget.nodeName == "richlistbox") {
        return;
    } else {
        while (dropTarget && (dropTarget.nodeName != "richlistitem")) {
            dropTarget = dropTarget.parentNode;
        }
    }
    return dropTarget;
}
flock_tagDNDObserver.onDrop = function(aEvent, aXferData, aDragSession) {
    try {
    var flockFavorites = flock_getFavoritesService();
    var props = Components.interfaces.flockIFavoriteProperties;

    var dropTarget = this.getDropItem(aEvent.target);
    if (!dropTarget || 
        (dropTarget.getAttribute('editable') != "true" 
         && dropTarget.getAttribute('dropable') != 'true')) {
        return;
    }
    XXX("DROPPED ON LISTITEM", dropTarget.id);
    var droppedData = flock_getDataFromDragSession(aDragSession);
    for (var i = 0; i < droppedData.length; ++i) {
        var uri = droppedData[i]['uri'];
        var title = droppedData[i]['title'];
        flockFavorites.createFavorite(
            uri,
            {   name: title,
                fields: props.FIELD_NAME }
        );
        if (dropTarget.hasAttribute("tag")) {
            flockFavorites.addTag(uri,dropTarget.getAttribute("tag"));
            flockFavorites.updateTagsField(uri);
        } else if (dropTarget.hasAttribute("collection")) {
            flockFavorites.addFavoriteToCollection(uri,dropTarget.getAttribute("collection"));
        }
    }

    } catch (e) {
        dd(e)
    }
    return true;
}
flock_tagDNDObserver.getSupportedFlavours = function () {
    var flavourSet = new FlavourSet();
    //flavourSet.appendFlavour("moz/rdfitem");
    flavourSet.appendFlavour("text/x-moz-url");
    flavourSet.appendFlavour("text/unicode");
    return flavourSet;
}/*}}}*/
// dnd handler for favorites tree/*{{{*/
var flock_favoriteDNDObserver = new DNDObserver();
flock_favoriteDNDObserver.onDragStart = function (aEvent, aXferData, aDragAction) {
    tree = aEvent.currentTarget;
    if (tree.getAttribute("sortActive") == "true") {
        throw Components.results.NS_OK; 
    }
    var selection = tree.view.selection;
    var data = flock_getXferDataFromSelection(selection);
    if (!data) {
        return;
    }    
    aXferData.data = data;
    if (aEvent.ctrlKey)
        aDragAction.action = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY;
};/*}}}*/
// dnd handler for history tree/*{{{*/
var flock_historyDNDObserver = new DNDObserver();
flock_historyDNDObserver.onDragStart = function (aEvent, aXferData, aDragAction) {
    tree = aEvent.currentTarget;
    if (tree.getAttribute("sortActive") == "true") {
        throw Components.results.NS_OK; 
    }
    var selection = tree.view.selection;
    var data = flock_getXferDataFromSelection(selection);
    if (!data) {
        return;
    }    
    aXferData.data = data;
    if (aEvent.ctrlKey)
        aDragAction.action = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY;
};/*}}}*/


// Initialization
function flock_initFavoriteManager() {/*{{{*/
    flock_initFavoriteView();
    flock_initHistoryView();
    flock_initCollectionView();
    flock_initTagView();
    //document.commandDispatcher.updateCommands('focus');
    window.addEventListener('focus',function () { document.commandDispatcher.updateCommands('focus'); },false);
    window.addEventListener('select',function () { document.commandDispatcher.updateCommands('select'); },false);
    window.focus();
    document.commandDispatcher.updateCommands('focus');
    flock_favoriteSharingPrompt ();
}/*}}}*/

// Initializing the right side.
function flock_initFavoriteView() {
    var tree = $('flock_favoriteView');
    var flockFavorites = flock_getFavoritesService();
    var RDF = flock_getRDFService();

    // Initialize the controller/*{{{*/
    var treeController = new CommandController();
    var windowController = new CommandController();    /*}}}*/
        
    // Base functor for these things
    var TreeIfSelectedFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            return (tree.view.selection.count);
        }
    }
    TreeIfSelectedFunctor.prototype = new Functor();/*}}}*/
    
    // The various functors to implement commands
    var cmd_flock_favoriteRemove = new Functor();/*{{{*/
    cmd_flock_favoriteRemove.isEnabled = function () {
        if (tree.view.selection.count) {
            var rangeMin = {};
            var rangeMax = {};
            
            tree.view.selection.getRangeAt(0, rangeMin, rangeMax);
            XXX('MINMAX', rangeMin.value, rangeMax.value);
            
            for (var i = rangeMin.value; i <= rangeMax.value; ++i) {
                if (tree.view.getParentIndex(i) != -1) {
                    return false;
                }
            }
            return true;
        }
        return false;
    };
    cmd_flock_favoriteRemove.exec = function () {
        var curRoot = tree.ref;
        var selection = tree.view.selection;
        if (selection.count == 0) {
            return null;
        }
        var rangeMin = {};
        var rangeMax = {};
        
        selection.getRangeAt(0, rangeMin, rangeMax);
        XXX('MINMAX', rangeMin.value, rangeMax.value);
        
        for (var i = rangeMin.value; i <= rangeMax.value; ++i) {
            var rsrc = tree.view.getResourceAtIndex(rangeMin.value);    
            var url = rsrc.Value;
            if (curRoot == "http://flock.com/rdf#FavoritesRoot") {
                // Remove favorite cmpletely
                flockFavorites.removeFavorite(url);
            } else {
                // Remove favorite from whatever collection is currently selected
                flockFavorites.removeFavoriteFromCollection(url, RDF.GetResource(curRoot));
            }
        }

        //var curIndex = tree.view.selection.currentIndex;
        //tree.view.performActionOnRow('delete',curIndex);
        //var rsrc = tree.view.getResourceAtIndex(curIndex);
        

        //var propre = Components.classes['@mozilla.org/supports-array;1'].createInstance(Components.interfaces.nsISupportsArray);
        //tree.view.getRowProperties(curIndex, propre);
        
        //var enum = propre.Enumerate();
        //if (enum.first()) {
        //    do {
        //        p = enum.currentItem();
        //        dd(p);
        //    } while (enum.next());
        //}

        //var curItem = tree.view.getItemAtIndex(curIndex);
        //var url = tree.view.getCellText(curIndex, tree.columns.getNamedColumn('URL'));
        ////alert("you tried to delete something!" + curIndex);
        //alert(curRoot);
    };
    treeController.cmd_delete = cmd_flock_favoriteRemove;
    treeController.cmd_flock_favoriteRemove = cmd_flock_favoriteRemove;
    windowController.cmd_delete = cmd_flock_favoriteRemove;/*}}}*/
    var cmd_flock_favoriteProperties = new TreeIfSelectedFunctor();/*{{{*/
    cmd_flock_favoriteProperties.exec = function () {
        var curIndex = tree.view.selection.currentIndex;
        //alert("you tried to view the properties of something!" + curIndex);
        var rsrc = tree.view.getResourceAtIndex(curIndex);
        var favorite = rsrc.Value;
        var value = {};
        openDialog("chrome://browser/content/flock/favorites/favoriteProperties.xul",
                   "", "centerscreen,chrome,modal,resizable=no", favorite, value);
        $('flock_tagView').builder.rebuild();
        return value.ok;
    };
    treeController.cmd_flock_favoriteProperties = cmd_flock_favoriteProperties;/*}}}*/
    var cmd_flock_favoriteViewAgg = new TreeIfSelectedFunctor();/*{{{*/
    cmd_flock_favoriteViewAgg.isEnabled = function () {
        if (!tree.view.selection.count) {
            return false;
        }
        var index = tree.view.selection.currentIndex;
        var rsrc = tree.view.getResourceAtIndex(index);
        if (!tree.view.isContainer(index) && !flock_isFeed(rsrc)) {
            return false;
        }
        return true;
    };
    cmd_flock_favoriteViewAgg.exec = function () {
        var index = tree.view.selection.currentIndex;
        var rsrc = tree.view.getResourceAtIndex(index);
        var feeds;
        if (tree.view.isContainer(index)) {
            feeds = flockFavorites.getFeeds(rsrc.Value, {});
        } else {
            feeds = [rsrc.Value];
        }
        flock_gotoAgg(feeds);  
    };
    treeController.cmd_flock_favoriteViewAgg = cmd_flock_favoriteViewAgg;/*}}}*/
    var cmd_flock_favoriteViewWeb = new TreeIfSelectedFunctor();/*{{{*/
    cmd_flock_favoriteViewWeb.isEnabled = function () {
        if (!tree.view.selection.count) {
            return false;
        }
        var index = tree.view.selection.currentIndex;
        var rsrc = tree.view.getResourceAtIndex(index);
        if (flock_isFeed(rsrc)) {
            return false;
        }
        return true;
    };
    cmd_flock_favoriteViewWeb.exec = function () {
        var index = tree.view.selection.currentIndex;
        var rsrc = tree.view.getResourceAtIndex(index);
        
        if (flock_isFeed(rsrc)) {
            return;
        }
        // if allowed web view
        flock_goto(rsrc.Value);
    };
    treeController.cmd_flock_favoriteViewWeb = cmd_flock_favoriteViewWeb;/*}}}*/

    // Add all the controllers to the right places/*{{{*/
    tree.controllers.appendController(treeController);
    window.controllers.appendController(windowController);/*}}}*/

    // nsIXULTreeBuilderObserver
    var flock_favoritesBuilderObserver = {
        // Constants/*{{{*/
        DROP_BEFORE: -1,
        DROP_ON: 0,
        DROP_AFTER: 1, /*}}}*/
        canDrop: function (aIndex, aOrientation) {/*{{{*/
            return (aOrientation != this.DROP_ON);
        },/*}}}*/
        onDrop: function (aRow, aOrientation) {/*{{{*/
            XXX('ONDROP', aRow, aOrientation);

            var dragSession = flock_getDragService().getCurrentSession();
            if (!dragSession) {
                return;
            }
            var flockFavorites = flock_getFavoritesService();
            var props = Components.interfaces.flockIFavoriteProperties;
            var tree = $('flock_favoriteView');
            var collection = flock_getResource(tree.ref);
            //var dropIndex = aRow + aOrientation;
            var dropIndex = aRow;
            var droppedData = flock_getDataFromDragSession(dragSession);
            for (var i = 0; i < droppedData.length; ++i) {
                // ensure favorite exists            
                var uri = droppedData[i]['uri'];
                var title = droppedData[i]['title'];
                flockFavorites.createFavorite(
                   uri,
                    {   name: title,
                        fields: props.FIELD_NAME }
                );
            
                flockFavorites.orderFavoriteInCollection(uri,collection,dropIndex);
            }
        },/*}}}*/
        onToggleOpenState: function (aIndex) {/*{{{*/
            XXX('TOGGLE OPEN STATE', aIndex);
        },/*}}}*/
        onCycleHeader: function (aCol, aElement) {/*{{{*/
            XXX('CYCLE HEADER', aCol, aElement);
        },/*}}}*/
        onCycleCell: function (aRow, aCol) {/*{{{*/
            XXX('CYCLE CELL', aRow, aCol);
            var rsrc;
            if (aCol == "aggButton") {
                tree.view.selection.select(aRow);
                tree.focus();
                goDoCommand('cmd_flock_favoriteViewAgg');
            }
            if (aCol == "webButton") {
                tree.view.selection.select(aRow);
                tree.focus();
                goDoCommand('cmd_flock_favoriteViewWeb');
            }
        },/*}}}*/
        onSelectionChanged: function () {/*{{{*/
            XXX('SELECTION CHANGED');
        },/*}}}*/
        onPerformAction: function (aAction) {/*{{{*/
            XXX('PERFORM ACTION', aAction);
        },/*}}}*/
        onPerformActionOnRow: function (aAction, aRow) {/*{{{*/
            XXX('PERFORM ACTION ON ROW', aAction, aRow);
            if (aAction == "dblclick") {
                XXX('DOI T!');
                tree.view.selection.select(aRow);
                tree.focus();
                if (flock_isFeed(tree.view.getResourceAtIndex(aRow))) {
                    goDoCommand('cmd_flock_favoriteViewAgg');
                } else {
                    goDoCommand('cmd_flock_favoriteViewWeb');
                }
            }
        },/*}}}*/
        onPerformActionOnCell: function (aAction, aRow, aCol) {/*{{{*/
            XXX('PERFORM ACTION ON CELL', aAction, aRow, aCol);
        }/*}}}*/
    }

    var flock_favoritesTreeClicker = new flock_treeClicker(tree);

    // Add the tree builder observer/*{{{*/
    var treeBuilder = tree.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
    treeBuilder.addObserver(flock_favoritesBuilderObserver);/*}}}*/
    
    // Add the click listeners to the the tree/*{{{*/
    tree.addEventListener("click", function (aEvent) { flock_favoritesTreeClicker.click(aEvent); }, false);
    tree.addEventListener("dblclick", function (aEvent) { flock_favoritesTreeClicker.click(aEvent); }, false);/*}}}*/
}

function flock_initHistoryView() {
    var tree = $('flock_historyView');
    var flockFavorites = flock_getFavoritesService();

    // Initialize the controller/*{{{*/
    var treeController = new CommandController();
    var windowController = new CommandController();    /*}}}*/
        
    // Base functor for these things
    var TreeIfSelectedFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            XXX('SELETION COUNT',tree.view.selection.count);
            return (tree.view.selection.count);
        }
    }
    TreeIfSelectedFunctor.prototype = new Functor();/*}}}*/
    
    // The various functors to implement commands
    var cmd_flock_historyViewAgg = new TreeIfSelectedFunctor();/*{{{*/
    // Disabled for now, no history items get agg view
    cmd_flock_historyViewAgg.isEnabled = function () { 
        var index = tree.view.selection.currentIndex;
        var rsrc = tree.view.getResourceAtIndex(index);
        if (!tree.view.isContainer(index) || !flock_isFeed(rsrc)) {
            return false;
        }
        return true;
    }
    cmd_flock_historyViewAgg.exec = function () {
        var index = tree.view.selection.currentIndex;
        var rsrc = tree.view.getResourceAtIndex(index);
        var feeds;
        if (tree.view.isContainer(index)) {
            feeds = flockFavorites.getFeeds(rsrc.Value, {});
        } else if (flock_isFeed(rsrc)) {
            feeds = [rsrc.Value];
        } else {
            return;
        }
        flock_gotoAgg(feeds); 
    };
    treeController.cmd_flock_historyViewAgg = cmd_flock_historyViewAgg;/*}}}*/
    var cmd_flock_historyViewWeb = new TreeIfSelectedFunctor();/*{{{*/
    cmd_flock_historyViewWeb.isEnabled = function () {
        var index = tree.view.selection.currentIndex;
        var rsrc = tree.view.getResourceAtIndex(index);
        if (flock_isFeed(rsrc)) {
            return false;
        }
        return true;
    };
    cmd_flock_historyViewWeb.exec = function () {
        var index = tree.view.selection.currentIndex;
        var rsrc = tree.view.getResourceAtIndex(index);
        // if allowed web view
        flock_goto(rsrc.Value);
    };
    treeController.cmd_flock_historyViewWeb = cmd_flock_historyViewWeb;/*}}}*/

    // Add all the controllers to the right places/*{{{*/
    tree.controllers.appendController(treeController);/*}}}*/

    // nsIXULTreeBuilderObserver
    var flock_historyBuilderObserver = {
        // Constants/*{{{*/
        DROP_BEFORE: -1,
        DROP_ON: 0,
        DROP_AFTER: 1, /*}}}*/
        canDrop: function (aIndex, aOrientation) {/*{{{*/
            return false;
        },/*}}}*/
        onDrop: function (aRow, aOrientation) {/*{{{*/
            XXX('ONDROP', aRow, aOrientation);
        },/*}}}*/
        onToggleOpenState: function (aIndex) {/*{{{*/
            XXX('TOGGLE OPEN STATE', aIndex);
        },/*}}}*/
        onCycleHeader: function (aCol, aElement) {/*{{{*/
            XXX('CYCLE HEADER', aCol, aElement);
        },/*}}}*/
        onCycleCell: function (aRow, aCol) {/*{{{*/
            XXX('CYCLE CELL', aRow, aCol);
            var rsrc;
            if (aCol == "h_aggButton") {
                tree.view.selection.select(aRow);
                tree.focus();
                goDoCommand('cmd_flock_historyViewAgg');
            }
            if (aCol == "h_webButton") {
                tree.view.selection.select(aRow);
                tree.focus();
                goDoCommand('cmd_flock_historyViewWeb');
            }
            

        },/*}}}*/
        onSelectionChanged: function () {/*{{{*/
            XXX('SELECTION CHANGED');
        },/*}}}*/
        onPerformAction: function (aAction) {/*{{{*/
            XXX('PERFORM ACTION', aAction);
        },/*}}}*/
        onPerformActionOnRow: function (aAction, aRow) {/*{{{*/
            XXX('PERFORM ACTION ON ROW', aAction, aRow);
        },/*}}}*/
        onPerformActionOnCell: function (aAction, aRow, aCol) {/*{{{*/
            XXX('PERFORM ACTION ON CELL', aAction, aRow, aCol);
        }/*}}}*/
    }

    // Add the tree builder observer/*{{{*/
    var treeBuilder = tree.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
    treeBuilder.addObserver(flock_historyBuilderObserver);/*}}}*/
}


// Initializing the left side.
function flock_initCollectionView() {
    var list = $('flock_collectionView');
    var flockFavorites = flock_getFavoritesService();
    var RDF = flock_getRDFService();
    var props = Components.interfaces.flockIFavoriteProperties;

    // Initialize the controllers/*{{{*/
    var listController = new CommandController();
    var windowController = new CommandController();    /*}}}*/

    // Base functor for these things
    var ListIfSelectedFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            return (list.selectedCount);
        }
    }
    ListIfSelectedFunctor.prototype = new Functor();/*}}}*/
    var ListIfEditableFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            if (!list.selectedCount) {
                return false;
            }
            var curIndex = list.currentIndex;
            var curItem = list.getItemAtIndex(curIndex);
            if (curItem.getAttribute('editable') != "true") {
                return false;
            }
            return true;
        }
    }
    ListIfEditableFunctor.prototype = new Functor();/*}}}*/
    
    // The various functors to implement commands
    var cmd_flock_collectionRemove = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionRemove.exec = function () {
        var curIndex = list.currentIndex;
        var curItem = list.getItemAtIndex(curIndex);
        flockFavorites.removeCollection(RDF.GetResource(curItem.resource.Value));
    };
    listController.cmd_delete = cmd_flock_collectionRemove;
    listController.cmd_flock_collectionRemove = cmd_flock_collectionRemove;
    windowController.cmd_flock_collectionRemove = cmd_flock_collectionRemove;
        /*}}}*/
    var cmd_flock_collectionCreate = new Functor();/*{{{*/
    cmd_flock_collectionCreate.exec = function () {
        // Make the new collection
        //var root = RDF.GetResource("NC:FavoritesRoot");      
        //var rsrc = BMSVC.createCollectionInContainer("I'm so new", root, -1);
        //list.builder.rebuild();

        var collection = flockFavorites.createCollection(
            {   name: "I'm new here", 
                fields: props.FIELD_NAME}
        );
        //dd(collection);
        //alert("Tried to create a new collection!");       
        list.builder.rebuild();
        //// Select it
        var newItem = list.lastChild;
        list.selectedItem = newItem;
        // Call rename on it
        goDoCommand('cmd_flock_collectionProperties');
        
    };
    listController.cmd_flock_collectionCreate = cmd_flock_collectionCreate;
    windowController.cmd_flock_collectionCreate = cmd_flock_collectionCreate;/*}}}*/
    var cmd_flock_collectionRename = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionRename.exec = function () {
        //var curItem = list.selectedItem;
        //// Hide child
        //curItem.firstChild.hidden = "true";
        //var textBox = document.createElement("textbox");
        //curItem.appendChild(textBox);
        goDoCommand('cmd_flock_collectionProperties');
    };
    listController.cmd_flock_collectionRename = cmd_flock_collectionRename;/*}}}*/
    var cmd_flock_collectionProperties = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionProperties.exec = function () {
        XXX('TOTALL HERE!');
        var curItem = list.selectedItem;
        var collection = curItem.resource.Value;
        var value = {};
        openDialog("chrome://browser/content/flock/favorites/collectionProperties.xul",
                   "", "centerscreen,chrome,modal,resizable=no", collection, value);
        return value.ok;
    };
    listController.cmd_flock_collectionProperties = cmd_flock_collectionProperties;
    windowController.cmd_flock_collectionProperties = cmd_flock_collectionProperties;/*}}}*/
    var cmd_flock_collectionViewAgg = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionViewAgg.isEnabled = function () {
        if (!list.selectedCount) {
            return false;
        }
        var curIndex = list.currentIndex;
        var curItem = list.getItemAtIndex(curIndex);
        if (curItem.getAttribute('editable') != "true") {
            return false;
        }
        return true;
        var ds = new RDFDataSource("rdf:flock-favorites");
        var node = ds.getNode(curItem.getAttribute('collection'));        
        var children = node.getChildren();
        var outArr = new Array();
        var urlList;
        var index = 0;
        while (children && children.hasMoreElements()) {
            var curChild = children.getNext();
            var count = {};
            var feeds = flockFavorites.getFeeds(curChild.getValue(),count);
            if (feeds.length > 0) {
                for (var i = 0;i < feeds.length; i++) {
                    XXX("FEED",feeds[i]);
                    outArr[index] = "li" + index + "=" + feeds[i];
                    index++;
                }
            }
        }
        if (outArr.length > 0) {
            return true;
        }
        return false;

    };
    cmd_flock_collectionViewAgg.exec = function () {
        var curItem = list.selectedItem;
        var ds = new RDFDataSource("rdf:flock-favorites");
        var node = ds.getNode(curItem.getAttribute('collection'));        
        var children = node.getChildren();
        var outArr = new Array();
        var urlList;
        var index = 0;
        while (children && children.hasMoreElements()) {
            var curChild = children.getNext();
            XXX(curChild.getValue());
            var count = {};
            var feeds = flockFavorites.getFeeds(curChild.getValue(),count);
            if (feeds.length > 0) {
                outArr = outArr.concat(feeds);
                //for (var i = 0;i < feeds.length; i++) {
                //    XXX("FEED",feeds[i]);
                //    outArr[index] = "li" + index + "=" + feeds[i];
                //    index++;
                //}
            }
        }
        if (outArr.length > 0) {
            flock_gotoAgg(outArr);
        }
        //urlList = outArr.join("&")
        
        //top.content.location = "chrome://browser/content/flock/rss/aggview.xul?"+urlList;


        //alert("You just tried to agg view something..." + curItem);
    };
    listController.cmd_flock_collectionViewAgg = cmd_flock_collectionViewAgg;/*}}}*/

    // Add the observer to update the feed buttons
    var flock_collectionRDFObserver = {
        _batch: false,
        updateAggButtonsDelayed: function () {/*{{{*/
            if (this._batch) {
                return;
            }
            this.startBatch();
            var me = this;
            window.setTimeout(function () { me.updateAggButtons(); me.endBatch(); }, 500);
        },/*}}}*/
        updateAggButtons: function () {/*{{{*/
            XXX('UPDATE AGG BUTTONS');
            //var visRows = list.getNumberOfVisibleRows();
            //var firstVis = list.getIndexOfFirstVisibleRow();
            var rowCount = list.getRowCount();
            XXX('ROWCOTUNT',rowCount);
            for (var i = 0; i < rowCount; ++i) {
                XXX('UPDATE AGG BUTTON FOR INDEX', i);
                var curItem = list.getItemAtIndex(i);
                var ds = new RDFDataSource("rdf:flock-favorites");
                var node = ds.getNode(curItem.getAttribute('collection'));        
                var children = node.getChildren();
                var outArr = new Array();
                var urlList;
                var index = 0;
                while (children && children.hasMoreElements()) {
                    var curChild = children.getNext();
                    var count = {};
                    var feeds = flockFavorites.getFeeds(curChild.getValue(),count);
                    if (feeds.length > 0) {
                        for (var j = 0;j < feeds.length; j++) {
                            XXX("FEED",feeds[j]);
                            outArr[index] = "li" + index + "=" + feeds[j];
                            index++;
                        }
                    }
                    if (outArr.length > 1) {
                        break;
                    }
                }
                if (outArr.length < 1) {
                    curItem.setAttribute('feeds','0');
                } else if (outArr.length == 1) {
                    curItem.setAttribute('feeds','1');
                } else {
                    curItem.setAttribute('feeds','2');
                }
            }
        },/*}}}*/
        startBatch: function () {/*{{{*/
            this._batch = true;
        },/*}}}*/
        endBatch: function () {/*{{{*/
            this._batch = false;
        },/*}}}*/
        onAssert: function () { this.updateAggButtonsDelayed() },
        onBeginUpdateBatch: function () { },
        onChange: function () { },
        onEndUpdateBatch: function () { },
        onMove: function () { },
        onUnassert: function () { },
    };

    // Add all the controllers to the right places/*{{{*/
    list.controllers.appendController(listController);
    top.controllers.appendController(windowController);/*}}}*/

    // Add the RDFObserver to the database/*{{{*/
    list.database.AddObserver(flock_collectionRDFObserver);/*}}}*/
    flock_collectionRDFObserver.updateAggButtons();
}


function flock_initTagView() {
    var list = $('flock_tagView');
    var flockFavorites = flock_getFavoritesService();
    var RDF = flock_getRDFService();
    var props = Components.interfaces.flockIFavoriteProperties;

    // Initialize the controllers/*{{{*/
    var listController = new CommandController();
    var windowController = new CommandController();    /*}}}*/

    // Base functor for these things
    var ListIfSelectedFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            return (list.selectedCount);
        }
    }
    ListIfSelectedFunctor.prototype = new Functor();/*}}}*/
    var ListIfEditableFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            if (!list.selectedCount) {
                return false;
            }
            var curIndex = list.currentIndex;
            var curItem = list.getItemAtIndex(curIndex);
            if (curItem.getAttribute('editable') != "true") {
                return false;
            }
            return true;
        }
    }
    ListIfEditableFunctor.prototype = new Functor();/*}}}*/
    
    // The various functors to implement commands
    var cmd_flock_collectionRemove = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionRemove.exec = function () {
        var curIndex = list.currentIndex;
        var curItem = list.getItemAtIndex(curIndex);
        flockFavorites.removeCollection(RDF.GetResource(curItem.resource.Value));
    };
    listController.cmd_delete = cmd_flock_collectionRemove;
    listController.cmd_flock_collectionRemove = cmd_flock_collectionRemove;
    windowController.cmd_flock_collectionRemove = cmd_flock_collectionRemove;
        /*}}}*/
    var cmd_flock_collectionCreate = new Functor();/*{{{*/
    cmd_flock_collectionCreate.exec = function () {
        // Make the new collection
        //var root = RDF.GetResource("NC:FavoritesRoot");      
        //var rsrc = BMSVC.createCollectionInContainer("I'm so new", root, -1);
        //list.builder.rebuild();

        var collection = flockFavorites.createCollection(
            {   name: "I'm new here", 
                fields: props.FIELD_NAME}
        );
        //dd(collection);
        //alert("Tried to create a new collection!");       
        list.builder.rebuild();
        //// Select it
        var newItem = list.lastChild;
        list.selectedItem = newItem;
        // Call rename on it
        goDoCommand('cmd_flock_collectionProperties');
        
    };
    listController.cmd_flock_collectionCreate = cmd_flock_collectionCreate;
    windowController.cmd_flock_collectionCreate = cmd_flock_collectionCreate;/*}}}*/
    var cmd_flock_collectionRename = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionRename.exec = function () {
        //var curItem = list.selectedItem;
        //// Hide child
        //curItem.firstChild.hidden = "true";
        //var textBox = document.createElement("textbox");
        //curItem.appendChild(textBox);
        goDoCommand('cmd_flock_collectionProperties');
    };
    listController.cmd_flock_collectionRename = cmd_flock_collectionRename;/*}}}*/
    var cmd_flock_collectionProperties = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionProperties.exec = function () {
        XXX('TOTALL HERE!');
        var curItem = list.selectedItem;
        var collection = curItem.resource.Value;
        var value = {};
        openDialog("chrome://browser/content/flock/favorites/collectionProperties.xul",
                   "", "centerscreen,chrome,modal,resizable=no", collection, value);
        return value.ok;
    };
    listController.cmd_flock_collectionProperties = cmd_flock_collectionProperties;
    windowController.cmd_flock_collectionProperties = cmd_flock_collectionProperties;/*}}}*/
    var cmd_flock_collectionViewAgg = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionViewAgg.exec = function () {
        var curItem = list.selectedItem;
        var ds = new RDFDataSource("rdf:flock-favorites");
        var node = ds.getNode(curItem.getAttribute('collection'));        
        var children = node.getChildren();
        var outArr = new Array();
        var urlList;
        var index = 0;
        while (children && children.hasMoreElements()) {
            var curChild = children.getNext();
            XXX(curChild.getValue());
            var count = {};
            var feeds = flockFavorites.getFeeds(curChild.getValue(),count);
            if (feeds.length > 0) {
                for (var i = 0;i < feeds.length; i++) {
                    XXX("FEED",feeds[i]);
                    outArr[index] = "li" + index + "=" + feeds[i];
                    index++;
                }
            }
        }
        urlList = outArr.join("&")
        
        top.content.location = "chrome://browser/content/flock/rss/aggview.xul?"+urlList;


        //alert("You just tried to agg view something..." + curItem);
    };
    listController.cmd_flock_collectionViewAgg = cmd_flock_collectionViewAgg;/*}}}*/

    // Add all the controllers to the right places/*{{{*/
    list.controllers.appendController(listController);
    window.controllers.appendController(windowController);/*}}}*/

    // Try to force a sort
    list.builder.rebuild();
}
