// vim: foldmethod=marker
//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


// These fools need to be refactored into something that can be reused
function flock_getXferDataFromSelection (aSelection) {/*{{{*/
    if (aSelection.count == 0)
        return null;
    var tree = aSelection.tree;
    var dataSet = new TransferDataSet();
    var data, item, itemUrl, itemName, parent, name;
    
    var rangeMin = {};
    var rangeMax = {};

    aSelection.getRangeAt(0, rangeMin, rangeMax);
    
    XXX('MINMAX', rangeMin.value, rangeMax.value);
    var anyData = false;    

    for (var i = rangeMin.value; i <= rangeMax.value; i++) {
        XXX('ON ITEM', i);
        // Skip feeds
        if (tree.view.getParentIndex(i) != -1) {
            XXX('SKIPPING FEED AT', i);
            continue;
        }

        data     = new TransferData();

        //item     = aSelection.item[i].Value;
        //itemUrl  = flock_getProperty(item, "http://home.netscape.com/NC-rdf#URL");
        //itemName = flock_getProperty(item, "http://home.netscape.com/NC-rdf#Name");
        //item = tree.view.getResourceAtIndex(i);
        itemUrl = flock_getCellText(aSelection.tree, i, "URL");
        itemName = flock_getCellText(aSelection.tree, i, "Name");
        //parent   = aSelection.parent[i].Value;
        //data.addDataForFlavour("moz/rdfitem",    item+"\n"+(parent?parent:""));
        //data.addDataForFlavour("moz/rdfitem",    item);
        data.addDataForFlavour("text/x-moz-url", itemUrl+"\n"+itemName);
        data.addDataForFlavour("text/html",      "<a href='"+itemUrl+"'>"+itemName+"</a>");
        data.addDataForFlavour("text/unicode",   itemUrl);
        dataSet.push(data);
        anyData = true;
    }
    if (!anyData) {
        return;
    }
    return dataSet;
}/*}}}*/
function flock_getDataFromDragSession (aDragSession) {/*{{{*/
    var trans = Components.classes['@mozilla.org/widget/transferable;1'].createInstance(Components.interfaces.nsITransferable);
    //trans.addDataFlavor("moz/rdfitem");
    trans.addDataFlavor("text/x-moz-url");
    trans.addDataFlavor("text/unicode");
    var uri, title;
    
    var arr = [];

    for (var i = 0; i < aDragSession.numDropItems; ++i) {
        var bestFlavour = {};
        var dataObj = {};
        var len = {};
        aDragSession.getData(trans, i);
        trans.getAnyTransferData(bestFlavour, dataObj, len);
        dataObj = dataObj.value.QueryInterface(Components.interfaces.nsISupportsString);
        if (!dataObj) {
            continue;
        }
        dataObj = dataObj.data.substr(0, len.value).split("\n");
        uri = dataObj[0];
        if (dataObj.length > 1 && dataObj[1] != "") {
            title = dataObj[1];
        } else {
            title = uri;
        }
        arr.push({uri: uri, title: title});
    }
    return arr;
}/*}}}*/
function flock_getProperty (aInput, aArcURI, aDS) {/*{{{*/
    var node;
    var RDF = flock_getRDFService();
    var arc  = RDF.GetResource(aArcURI);
    if (typeof(aInput) == "string") {
        aInput = RDF.GetResource(aInput);
    }
    if (!aDS) {
        node = flock_getFavoritesService().GetTarget(aInput, arc, true);
    } 
    else {
        node = aDS .GetTarget(aInput, arc, true);
    }
    try {
        return node.QueryInterface(Components.interfaces.nsIRDFResource).Value;
    }
    catch (e) {
        return node ? node.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : "";
    }    
}/*}}}*/
function flock_getCellText(aTree, aRow, aColName) {/*{{{*/
    // Quick hack to allow this to grab from favorites OR history
    var col = aTree.columns.getNamedColumn(aColName) || aTree.columns.getNamedColumn("h_" + aColName);
    return aTree.view.getCellText(aRow, col);
}/*}}}*/
function flock_gotoAgg(aFeeds) {/*{{{*/
    var outArr = new Array();
    for (var i = 0;i < aFeeds.length;i++) {
        outArr.push("li" + i + "=" + escape(aFeeds[i]));
    }
    flock_goto("chrome://browser/content/flock/rss/aggview.xul?"+outArr.join("&"));   
}/*}}}*/
function flock_isFeed(aRsrc) {/*{{{*/
    // test whether it is a feed
    if (flock_getProperty(aRsrc, "http://home.netscape.com/NC-rdf#FeedURL")) {
        return true;
    }
    return false;
}/*}}}*/




function flock_switchSideToCollection() {/*{{{*/
    $('flock_managerTabCollections').setAttribute('selected','true');
    $('flock_managerTabTags').removeAttribute('selected');
    $('flock_sideView').selectedPanel = $('flock_collectionPanel');

}/*}}}*/
function flock_switchSideToTag() {/*{{{*/
    $('flock_managerTabTags').setAttribute('selected','true');
    $('flock_managerTabCollections').removeAttribute('selected');
    $('flock_sideView').selectedPanel = $('flock_tagPanel');

}/*}}}*/


// Drag and drop handlers
// dnd handler for collections list /*{{{*/
var flock_collectionDNDObserver = new DNDObserver();
flock_collectionDNDObserver.onDragOver = function (aEvent, aFlavour, aDragSession) {
    aDragSession.dragAction = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY;
    var dropTarget = this.getDropItem(aEvent.target);
    if (!dropTarget || 
        (dropTarget.getAttribute('editable') != "true" 
         && dropTarget.getAttribute('dropable') != 'true')) {
        return;
    }
    dropTarget.setAttribute("dragOver","true");
    dropTarget.setAttribute("allowevents","false");
    return true;
}
flock_collectionDNDObserver.onDragExit = function (aEvent, aDragSession) {
    var dropTarget = this.getDropItem(aEvent.target);
    if (dropTarget.nodeName != "listitem") {
        return;
    }
    dropTarget.removeAttribute("dragOver");
    // XXX termie: Aaaaarrggh!!
    dropTarget.setAttribute("allowevents","true");
  
}
flock_collectionDNDObserver.getDropItem = function (aTarget) {
    var dropTarget = aTarget;
 
    if (dropTarget.nodeName == "listbox") {
        return;
    } else {
        while (dropTarget && (dropTarget.nodeName != "listitem")) {
            dropTarget = dropTarget.parentNode;
        }
    }
    return dropTarget;
}
flock_collectionDNDObserver.getDropBox = function (aTarget) {
    var dropTarget = aTarget;
    if (dropTarget.nodeName != "listbox") {
        while (dropTarget && (dropTarget.nodeName != "listbox")) {
            dropTarget = dropTarget.parentNode;
        }
    }
    return dropTarget;
}
flock_collectionDNDObserver.onDrop = function(aEvent, aXferData, aDragSession) {
    try {
    var flockFavorites = flock_getFavoritesService();
    var props = Components.interfaces.flockIFavoriteProperties;

    var dropTarget = this.getDropItem(aEvent.target);
    if (!dropTarget || 
        (dropTarget.getAttribute('editable') != "true" 
         && dropTarget.getAttribute('dropable') != 'true')) {
        return;
    }
    XXX("DROPPED ON LISTITEM", dropTarget.id);
    var droppedData = flock_getDataFromDragSession(aDragSession);
    for (var i = 0; i < droppedData.length; ++i) {
        var uri = droppedData[i]['uri'];
        var title = droppedData[i]['title'];
        flockFavorites.createFavorite(
            uri,
            {   name: title,
                fields: props.FIELD_NAME }
        );   
        flockFavorites.addFavoriteToCollection(uri,dropTarget.resource);
    }

    } catch (e) {
        dd(e)
    }
    return true;
}
flock_collectionDNDObserver.getSupportedFlavours = function () {
    var flavourSet = new FlavourSet();
    //flavourSet.appendFlavour("moz/rdfitem");
    flavourSet.appendFlavour("text/x-moz-url");
    flavourSet.appendFlavour("text/unicode");
    return flavourSet;
}/*}}}*/
// dnd handler for tags list /*{{{*/
var flock_tagDNDObserver = new DNDObserver();
flock_tagDNDObserver.onDragOver = function (aEvent, aFlavour, aDragSession) {
    aDragSession.dragAction = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY;
    var dropTarget = this.getDropItem(aEvent.target);
    if (!dropTarget || 
        (dropTarget.getAttribute('editable') != "true" 
         && dropTarget.getAttribute('dropable') != 'true')) {
        return;
    }
    dropTarget.setAttribute("dragOver","true");
    dropTarget.setAttribute("allowevents","false");
    return true;
}
flock_tagDNDObserver.onDragExit = function (aEvent, aDragSession) {
    var dropTarget = this.getDropItem(aEvent.target);
    if (dropTarget.nodeName != "listitem") {
        return;
    }
    dropTarget.removeAttribute("dragOver");
    // XXX termie: Aaaaarrggh!!
    dropTarget.setAttribute("allowevents","true");
  
}
flock_tagDNDObserver.getDropItem = function (aTarget) {
    var dropTarget = aTarget;
 
    if (dropTarget.nodeName == "listbox") {
        return;
    } else {
        while (dropTarget && (dropTarget.nodeName != "listitem")) {
            dropTarget = dropTarget.parentNode;
        }
    }
    return dropTarget;
}
flock_tagDNDObserver.onDrop = function(aEvent, aXferData, aDragSession) {
    try {
    var flockFavorites = flock_getFavoritesService();
    var props = Components.interfaces.flockIFavoriteProperties;

    var dropTarget = this.getDropItem(aEvent.target);
    if (!dropTarget || 
        (dropTarget.getAttribute('editable') != "true" 
         && dropTarget.getAttribute('dropable') != 'true')) {
        return;
    }
    XXX("DROPPED ON LISTITEM", dropTarget.id);
    var droppedData = flock_getDataFromDragSession(aDragSession);
    for (var i = 0; i < droppedData.length; ++i) {
        var uri = droppedData[i]['uri'];
        var title = droppedData[i]['title'];
        flockFavorites.createFavorite(
            uri,
            {   name: title,
                fields: props.FIELD_NAME }
        );
        if (dropTarget.hasAttribute("tag")) {
            flockFavorites.addTag(uri,dropTarget.getAttribute("tag"));
            flockFavorites.updateTagsField(uri);
        } else if (dropTarget.hasAttribute("collection")) {
            flockFavorites.addFavoriteToCollection(uri,dropTarget.getAttribute("collection"));
        }
    }

    } catch (e) {
        dd(e)
    }
    return true;
}
flock_tagDNDObserver.getSupportedFlavours = function () {
    var flavourSet = new FlavourSet();
    //flavourSet.appendFlavour("moz/rdfitem");
    flavourSet.appendFlavour("text/x-moz-url");
    flavourSet.appendFlavour("text/unicode");
    return flavourSet;
}/*}}}*/



// Initialization
function flock_initFavoriteManager() {/*{{{*/
    flock_initCollectionView();
    flock_initTagView();
    //document.commandDispatcher.updateCommands('focus');
    window.addEventListener('focus',function () { document.commandDispatcher.updateCommands('focus'); },false);
    window.addEventListener('select',function () { document.commandDispatcher.updateCommands('select'); },false);
    window.focus();
    document.commandDispatcher.updateCommands('focus');
}/*}}}*/

// Initializing the left side.
function flock_initCollectionView() {
    var list = $('flock_collectionView');
    var flockFavorites = flock_getFavoritesService();
    var RDF = flock_getRDFService();
    var props = Components.interfaces.flockIFavoriteProperties;

    // Initialize the controllers/*{{{*/
    var listController = new CommandController();
    var windowController = new CommandController();    /*}}}*/

    // Base functor for these things
    var ListIfSelectedFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            return (list.selectedCount);
        }
    }
    ListIfSelectedFunctor.prototype = new Functor();/*}}}*/
    var ListIfEditableFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            if (!list.selectedCount) {
                return false;
            }
            var curIndex = list.currentIndex;
            var curItem = list.getItemAtIndex(curIndex);
            if (curItem.getAttribute('editable') != "true") {
                return false;
            }
            return true;
        }
    }
    ListIfEditableFunctor.prototype = new Functor();/*}}}*/
    
    // The various functors to implement commands
    var cmd_flock_collectionRemove = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionRemove.exec = function () {
        var curIndex = list.currentIndex;
        var curItem = list.getItemAtIndex(curIndex);
        flockFavorites.removeCollection(RDF.GetResource(curItem.resource.Value));
    };
    listController.cmd_delete = cmd_flock_collectionRemove;
    listController.cmd_flock_collectionRemove = cmd_flock_collectionRemove;
    windowController.cmd_flock_collectionRemove = cmd_flock_collectionRemove;
        /*}}}*/
    var cmd_flock_collectionCreate = new Functor();/*{{{*/
    cmd_flock_collectionCreate.exec = function () {
        // Make the new collection
        //var root = RDF.GetResource("NC:FavoritesRoot");      
        //var rsrc = BMSVC.createCollectionInContainer("I'm so new", root, -1);
        //list.builder.rebuild();

        var collection = flockFavorites.createCollection(
            {   name: "I'm new here", 
                fields: props.FIELD_NAME}
        );
        //dd(collection);
        //alert("Tried to create a new collection!");       
        list.builder.rebuild();
        //// Select it
        var newItem = list.lastChild;
        list.selectedItem = newItem;
        // Call rename on it
        goDoCommand('cmd_flock_collectionProperties');
        
    };
    listController.cmd_flock_collectionCreate = cmd_flock_collectionCreate;
    windowController.cmd_flock_collectionCreate = cmd_flock_collectionCreate;/*}}}*/
    var cmd_flock_collectionRename = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionRename.exec = function () {
        //var curItem = list.selectedItem;
        //// Hide child
        //curItem.firstChild.hidden = "true";
        //var textBox = document.createElement("textbox");
        //curItem.appendChild(textBox);
        goDoCommand('cmd_flock_collectionProperties');
    };
    listController.cmd_flock_collectionRename = cmd_flock_collectionRename;/*}}}*/
    var cmd_flock_collectionProperties = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionProperties.exec = function () {
        XXX('TOTALL HERE!');
        var curItem = list.selectedItem;
        var collection = curItem.resource.Value;
        var value = {};
        openDialog("chrome://browser/content/flock/favorites/collectionProperties.xul",
                   "", "centerscreen,chrome,modal,resizable=no", collection, value);
        return value.ok;
    };
    listController.cmd_flock_collectionProperties = cmd_flock_collectionProperties;
    windowController.cmd_flock_collectionProperties = cmd_flock_collectionProperties;/*}}}*/
    var cmd_flock_collectionViewAgg = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionViewAgg.isEnabled = function () {
        if (!list.selectedCount) {
            return false;
        }
        var curIndex = list.currentIndex;
        var curItem = list.getItemAtIndex(curIndex);
        if (curItem.getAttribute('editable') != "true") {
            return false;
        }
        return true;
        var ds = new RDFDataSource("rdf:flock-favorites");
        var node = ds.getNode(curItem.getAttribute('collection'));        
        var children = node.getChildren();
        var outArr = new Array();
        var urlList;
        var index = 0;
        while (children && children.hasMoreElements()) {
            var curChild = children.getNext();
            var count = {};
            var feeds = flockFavorites.getFeeds(curChild.getValue(),count);
            if (feeds.length > 0) {
                for (var i = 0;i < feeds.length; i++) {
                    XXX("FEED",feeds[i]);
                    outArr[index] = "li" + index + "=" + feeds[i];
                    index++;
                }
            }
        }
        if (outArr.length > 0) {
            return true;
        }
        return false;

    };
    cmd_flock_collectionViewAgg.exec = function () {
        var curItem = list.selectedItem;
        var ds = new RDFDataSource("rdf:flock-favorites");
        var node = ds.getNode(curItem.getAttribute('collection'));        
        var children = node.getChildren();
        var outArr = new Array();
        var urlList;
        var index = 0;
        while (children && children.hasMoreElements()) {
            var curChild = children.getNext();
            XXX(curChild.getValue());
            var count = {};
            var feeds = flockFavorites.getFeeds(curChild.getValue(),count);
            if (feeds.length > 0) {
                outArr = outArr.concat(feeds);
                //for (var i = 0;i < feeds.length; i++) {
                //    XXX("FEED",feeds[i]);
                //    outArr[index] = "li" + index + "=" + feeds[i];
                //    index++;
                //}
            }
        }
        if (outArr.length > 0) {
            flock_gotoAgg(outArr);
        }
        //urlList = outArr.join("&")
        
        //top.content.location = "chrome://browser/content/flock/rss/aggview.xul?"+urlList;


        //alert("You just tried to agg view something..." + curItem);
    };
    listController.cmd_flock_collectionViewAgg = cmd_flock_collectionViewAgg;/*}}}*/

    // Add the observer to update the feed buttons
    var flock_collectionRDFObserver = {
        _batch: false,
        updateAggButtonsDelayed: function () {/*{{{*/
            if (this._batch) {
                return;
            }
            this.startBatch();
            var me = this;
            window.setTimeout(function () { me.updateAggButtons(); me.endBatch(); }, 500);
        },/*}}}*/
        updateAggButtons: function () {/*{{{*/
            XXX('UPDATE AGG BUTTONS');
            //var visRows = list.getNumberOfVisibleRows();
            //var firstVis = list.getIndexOfFirstVisibleRow();
            var rowCount = list.getRowCount();
            XXX('ROWCOTUNT',rowCount);
            for (var i = 0; i < rowCount; ++i) {
                XXX('UPDATE AGG BUTTON FOR INDEX', i);
                var curItem = list.getItemAtIndex(i);
                var ds = new RDFDataSource("rdf:flock-favorites");
                var node = ds.getNode(curItem.getAttribute('collection'));        
                var children = node.getChildren();
                var outArr = new Array();
                var urlList;
                var index = 0;
                while (children && children.hasMoreElements()) {
                    var curChild = children.getNext();
                    var count = {};
                    var feeds = flockFavorites.getFeeds(curChild.getValue(),count);
                    if (feeds.length > 0) {
                        for (var j = 0;j < feeds.length; j++) {
                            XXX("FEED",feeds[j]);
                            outArr[index] = "li" + index + "=" + feeds[j];
                            index++;
                        }
                    }
                    if (outArr.length > 1) {
                        break;
                    }
                }
                if (outArr.length < 1) {
                    curItem.setAttribute('feeds','0');
                } else if (outArr.length == 1) {
                    curItem.setAttribute('feeds','1');
                } else {
                    curItem.setAttribute('feeds','2');
                }
            }
        },/*}}}*/
        startBatch: function () {/*{{{*/
            this._batch = true;
        },/*}}}*/
        endBatch: function () {/*{{{*/
            this._batch = false;
        },/*}}}*/
        onAssert: function () { this.updateAggButtonsDelayed() },
        onBeginUpdateBatch: function () { },
        onChange: function () { },
        onEndUpdateBatch: function () { },
        onMove: function () { },
        onUnassert: function () { },
    };

    // Add all the controllers to the right places/*{{{*/
    list.controllers.appendController(listController);
    top.controllers.appendController(windowController);/*}}}*/

    // Add the RDFObserver to the database/*{{{*/
    list.database.AddObserver(flock_collectionRDFObserver);/*}}}*/
    flock_collectionRDFObserver.updateAggButtons();
}


function flock_initTagView() {
    var list = $('flock_tagView');
    var flockFavorites = flock_getFavoritesService();
    var RDF = flock_getRDFService();
    var props = Components.interfaces.flockIFavoriteProperties;

    // Initialize the controllers/*{{{*/
    var listController = new CommandController();
    var windowController = new CommandController();    /*}}}*/

    // Base functor for these things
    var ListIfSelectedFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            return (list.selectedCount);
        }
    }
    ListIfSelectedFunctor.prototype = new Functor();/*}}}*/
    var ListIfEditableFunctor = function () {/*{{{*/
        var me = this;
        me.isEnabled = function() {
            if (!list.selectedCount) {
                return false;
            }
            var curIndex = list.currentIndex;
            var curItem = list.getItemAtIndex(curIndex);
            if (curItem.getAttribute('editable') != "true") {
                return false;
            }
            return true;
        }
    }
    ListIfEditableFunctor.prototype = new Functor();/*}}}*/
    
    // The various functors to implement commands
    var cmd_flock_collectionRemove = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionRemove.exec = function () {
        var curIndex = list.currentIndex;
        var curItem = list.getItemAtIndex(curIndex);
        flockFavorites.removeCollection(RDF.GetResource(curItem.resource.Value));
    };
    listController.cmd_delete = cmd_flock_collectionRemove;
    listController.cmd_flock_collectionRemove = cmd_flock_collectionRemove;
    windowController.cmd_flock_collectionRemove = cmd_flock_collectionRemove;
        /*}}}*/
    var cmd_flock_collectionCreate = new Functor();/*{{{*/
    cmd_flock_collectionCreate.exec = function () {
        // Make the new collection
        //var root = RDF.GetResource("NC:FavoritesRoot");      
        //var rsrc = BMSVC.createCollectionInContainer("I'm so new", root, -1);
        //list.builder.rebuild();

        var collection = flockFavorites.createCollection(
            {   name: "I'm new here", 
                fields: props.FIELD_NAME}
        );
        //dd(collection);
        //alert("Tried to create a new collection!");       
        list.builder.rebuild();
        //// Select it
        var newItem = list.lastChild;
        list.selectedItem = newItem;
        // Call rename on it
        goDoCommand('cmd_flock_collectionProperties');
        
    };
    listController.cmd_flock_collectionCreate = cmd_flock_collectionCreate;
    windowController.cmd_flock_collectionCreate = cmd_flock_collectionCreate;/*}}}*/
    var cmd_flock_collectionRename = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionRename.exec = function () {
        //var curItem = list.selectedItem;
        //// Hide child
        //curItem.firstChild.hidden = "true";
        //var textBox = document.createElement("textbox");
        //curItem.appendChild(textBox);
        goDoCommand('cmd_flock_collectionProperties');
    };
    listController.cmd_flock_collectionRename = cmd_flock_collectionRename;/*}}}*/
    var cmd_flock_collectionProperties = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionProperties.exec = function () {
        XXX('TOTALL HERE!');
        var curItem = list.selectedItem;
        var collection = curItem.resource.Value;
        var value = {};
        openDialog("chrome://browser/content/flock/favorites/collectionProperties.xul",
                   "", "centerscreen,chrome,modal,resizable=no", collection, value);
        return value.ok;
    };
    listController.cmd_flock_collectionProperties = cmd_flock_collectionProperties;
    windowController.cmd_flock_collectionProperties = cmd_flock_collectionProperties;/*}}}*/
    var cmd_flock_collectionViewAgg = new ListIfEditableFunctor();/*{{{*/
    cmd_flock_collectionViewAgg.exec = function () {
        var curItem = list.selectedItem;
        var ds = new RDFDataSource("rdf:flock-favorites");
        var node = ds.getNode(curItem.getAttribute('collection'));        
        var children = node.getChildren();
        var outArr = new Array();
        var urlList;
        var index = 0;
        while (children && children.hasMoreElements()) {
            var curChild = children.getNext();
            XXX(curChild.getValue());
            var count = {};
            var feeds = flockFavorites.getFeeds(curChild.getValue(),count);
            if (feeds.length > 0) {
                for (var i = 0;i < feeds.length; i++) {
                    XXX("FEED",feeds[i]);
                    outArr[index] = "li" + index + "=" + feeds[i];
                    index++;
                }
            }
        }
        urlList = outArr.join("&")
        
        top.content.location = "chrome://browser/content/flock/rss/aggview.xul?"+urlList;


        //alert("You just tried to agg view something..." + curItem);
    };
    listController.cmd_flock_collectionViewAgg = cmd_flock_collectionViewAgg;/*}}}*/

    // Add all the controllers to the right places/*{{{*/
    list.controllers.appendController(listController);
    window.controllers.appendController(windowController);/*}}}*/

    // Try to force a sort
    list.builder.rebuild();
}

