//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

const RSSCID = '@flock.com/rssservice;1';
const RSSIID = Components.interfaces.flockIRSSService;

const RSS_RDF_NS = "http://www.flock.com/rdf#"

const LOAD_TIMEOUT = 30 * 2;

var gRSSSvc = Components.classes[RSSCID].getService(RSSIID);
var gRSSDS = null;

function flock_expandAll(){
	var elms=document.getElementsByTagName('rssbox');
	for(i=0; i<elms.length; i++){
		var content = document.getAnonymousElementByAttribute(elms[i], "anonid", "rssbox-content");
        var button = document.getAnonymousElementByAttribute(elms[i], "anonid", "rssbox-button");		

                if (button.getAttribute("nobutton") != "true") {
		    content.removeAttribute("collapsed");
		    button.setAttribute('closed',false);
                }
	}
}

function flock_contractAll(){
	var elms=document.getElementsByTagName('rssbox');
	for(i=0; i<elms.length; i++){
		var content = document.getAnonymousElementByAttribute(elms[i], "anonid", "rssbox-content");
        var button = document.getAnonymousElementByAttribute(elms[i], "anonid", "rssbox-button");		

                dump("but: " + button.getAttribute("nobutton") + "\n");
                if (button.getAttribute("nobutton") != "true") {
  		    content.setAttribute("collapsed",true);
		    button.setAttribute('closed',true);
                }
	}
}

function clearChildren(node)
{
    children = new Array();
    for (var i = 0; i < node.childNodes.length; i++) {
        children.push(node.childNodes[i]);
    }

    for (var i = 0; i < children.length; i++) {
        node.removeChild(children[i]);
    }
}

function deferLoadView(sortkey, timeout)
{
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
    var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
    var topWindowOfType = windowManagerInterface.getMostRecentWindow( "navigator:browser" );

    var throbberElement = topWindowOfType.document.getElementById("navigator-throbber");

    var throbby = function () {
        throbberElement.setAttribute("busy", "true");
    };

    var unthrobby = function () {
        throbberElement.removeAttribute("busy");
        flock_loadView(sortkey, timeout - 1);
    };

    window.setTimeout(throbby, 0);
    window.setTimeout(unthrobby, 500);
}

function flock_loadView(sortkey, timeout)
{
    var qs = new flock_PageQuery(window.location.search);
    var urls = qs.getValues();

    var defer = false;
    for(var u in urls) {
        dump(urls[u] + "\n");

        if (!gRSSSvc.hasFeed(urls[u])) {
            gRSSSvc.addFeed(urls[u]);
            defer = true; 
        }
    }

    if (defer) {
         if (timeout == null)
             timeout = LOAD_TIMEOUT;

         if (timeout <= 0)
             return;

         return deferLoadView(sortkey, timeout);
    }

    if (!sortkey)
        sortkey = "dates";

    gRSSDS = gRSSSvc.getAggregateFeeds(sortkey, urls.length, urls);

    ds = new RDFDataSource();
    ds.Init(gRSSDS);
    //dump(ds.serializeToString() + '\n');

    $("rss_web_link").setAttribute('href', '#');

    if (urls.length == 1) {
        $("rss_feed_child_box").setAttribute('nostamps', 'true');

        sortkey = 'dates';

        var url = urls[0];

        var feedNode = ds.getNode(url);
        var link = feedNode.getTarget(RSS_RDF_NS + 'link');

        if (link) {
            $("rss_web_link").setAttribute('href', link.getValue());
            $("rss_web_link").setAttribute('class', 'switch-view');
        } else {
            $("rss_web_link").setAttribute('href', '#');
            $("rss_web_link").setAttribute('class', 'switch-view-disabled');
        }

        var title = feedNode.getTarget(RSS_RDF_NS + 'title').getValue();
        if (!title)
            title = url;

        clearChildren($("rss_view_title"));
        $("rss_view_title").appendChild(document.createTextNode(title));

        var author_sep = ' -- by ';

        var subtitle = feedNode.getTarget(RSS_RDF_NS + 'description');
        if (subtitle) {
            $("rss_view_subtitle").removeAttribute('style');
            clearChildren($("rss_view_subtitle"));
            $("rss_view_subtitle").appendChild(document.createTextNode(subtitle.getValue()));
        } else {
            $("rss_view_subtitle").setAttribute('style', 'display: none;');
            author_sep = '';
        }

        var author = feedNode.getTarget(RSS_RDF_NS + 'author');
        if (author) {
            if (author_sep)
                author = author_sep + author.getValue();
            else
                author = author.getValue();

            $("rss_view_author").removeAttribute('style');
            clearChildren($("rss_view_author"));
            $("rss_view_author").appendChild(document.createTextNode(author));
        } else {
            $("rss_view_author").setAttribute('style', 'display: none;');
        }
            $("rss_view_author").setAttribute('style', 'display: none;');
    } else {
        $("rss_feed_child_box").removeAttribute('nostamps');

        $("rss_web_link").setAttribute('href', '#');
        $("rss_web_link").setAttribute('class', 'switch-view-disabled');

        clearChildren($("rss_view_title"));
        $("rss_view_title").appendChild(document.createTextNode('Aggregated Feeds'));

        $("rss_view_subtitle").setAttribute('style', 'display: none;');
        $("rss_view_author").setAttribute('style', 'display: none;');
    }

    if (sortkey == 'feeds') {
        $("rss_feed_child_box").removeAttribute('titlestamp');

        $("rss_feed_parent_box").setAttribute('refresh', 'false');

        $("rss_date_sort_link").setAttribute('href', 'javascript:flock_loadView("dates")');
        $("rss_date_sort_link").removeAttribute('class');

        $("rss_feed_sort_link").setAttribute('href', '#');
        $("rss_feed_sort_link").setAttribute('class', 'disabled');
    } else {
        $("rss_feed_child_box").setAttribute('titlestamp', 'true');

        $("rss_feed_parent_box").setAttribute('refresh', 'false');

        $("rss_date_sort_link").setAttribute('href', '#');
        $("rss_date_sort_link").setAttribute('class', 'disabled');

        
        if (urls.length == 1) {
            $("rss_feed_sort_link").setAttribute('href', '#');
            $("rss_feed_sort_link").setAttribute('class', 'disabled');
        } else {
            $("rss_feed_sort_link").setAttribute('href', 'javascript:flock_loadView("feeds")');
            $("rss_feed_sort_link").removeAttribute('class');
        }
    }

    $("rss_feed_box").setAttribute('ref','urn:flock:rss:' + sortkey);
    $("rss_feed_box").database.RemoveDataSource(gRSSDS);
    $("rss_feed_box").database.AddDataSource(gRSSDS);
    $("rss_feed_box").builder.rebuild();
}

var flock_contentAreaDNDObserver = {
    onDragStart: function(event, transferData, action)
    {
        try
        {
            var selection = window.getSelection();
            var serializer = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer);
            var data = "";

			transferData.data=new TransferData();
            var range = selection.getRangeAt(0);

            if(range)
            {
                var fragment = range.cloneContents();
                data = serializer.serializeToString(fragment);
            }

            if(data=="")
            {
                data = serializer.serializeToString(selection.anchorNode);
            }

	    transferData.data.addDataForFlavour("text/html",data);
	    transferData.data.addDataForFlavour("text/unicode",data);
        }
        catch(e)
        {
           dump(e + "\n");
        }
	 },

    getSupportedFlavours: function ()
    {
        var flavourSet = new FlavourSet();
        flavourSet.appendFlavour("text/html");
        flavourSet.appendFlavour("text/unicode");
        return flavourSet;
    }

};

