//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

//const MARK_SELECTION_START = '\u200B\u200B\u200B\u200B\u200B';
//const MARK_SELECTION_END = '\u200C\u200C\u200C\u200C\u200C';
//const NS_XHTML = 'http://www.w3.org/1999/xhtml';
window.last_dragged_selection='';

var shelfObserver={
	 onDragOver: function(event,flavor,session){
			//dump('Dragged over!');
			//event.target.alternate();
	 },

	 onDrop: function(evt,dropData,asession){
		//If it's a shelfobject, it's a very special case that doesn't apply to anything else in the whole browser but the shelf, so keep the code here rather than in the more generalized stuff.
		if(asession.sourceNode.nodeName.toLowerCase()=='shelfobject'){
			var node=asession.sourceNode;
			var container=window.ds.getNode("urn:flock:shelf:objects");

			//Get nodes first so that dragging over others doesn't change things.
			var nextnode=window.ds.getNode('urn:flock:shelf:' + window.next_shelfobject.id);
			var thisnode=window.ds.getNode('urn:flock:shelf:' + node.id);

			//Now delete the current node.
			var this_idx=container.getChildIndex(thisnode);
			container.removeChildAt(this_idx);

			//Get the index (should be updated after the deletion) of the last node dragged over and add the old node.
			var next_idx=container.getChildIndex(nextnode);
			container.addChildAt(thisnode,next_idx);
			window.ds.save();

			//Now update the ui.
			var shelf=document.getElementById('shelf_box');
			
			//Clone the node to make sure it's the right kind of object. Then go through and explicitly set important things, as the true param passed doesn't seem to behave quite as expected to clone deeply and get all attributes.
			clone=node.cloneNode(true);
			clone.header=node.header;
			clone.src=node.src;
			clone.label=node.label;
			clone.className=node.className;
			clone.icon=node.icon;
			clone.addEventListener('draggesture',function(event){ nsDragAndDrop.startDrag(event,shelfObjObserver); },true);
			shelf.insertBefore(clone,window.next_shelfobject);
			node.parentNode.removeChild(node);
			adjust_shelfobject_sizes();
			//shelf.childNodes[0].alternate();
			clone.alternate(); //Redo colors.
			return;	
		}
		//Else do the generalized stuff.
		else{
			var data=flock_getMarkedUpSelection(evt,dropData,asession);
			var obj=document.createElement('shelfobject');
			var date=new Date();
			var num=date.getTime();
	
			obj.id='obj_' + num;
			obj.setAttribute('label',data.label);
			obj.setAttribute('header',data.header);
			obj.src=data.src;
			dump('SOURCE: ' + data.src + '\n');
			obj.setAttribute('icon','chrome://browser/skin/flock/shelf/' + data.type + '.png');
			obj.addEventListener('draggesture',function(event){ nsDragAndDrop.startDrag(event,shelfObjObserver); },true);
			shelf=document.getElementById('shelf_box');
			dump('TYPEOF window.next_shelfobject: ' + typeof window.next_shelfobject + '\n');
			if(window.next_shelfobject != ''){
				shelf.insertBefore(obj,window.next_shelfobject);
			}
			else{
				shelf.insertBefore(obj,shelf.firstChild);
			}
			obj.alternate();
			adjust_shelfobject_sizes();
			add_object(obj);
		}
	 },

	 onDragStart: function(event, transferData, action){
			dump('Drag started!');

			transferData.data=new TransferData();
			transferData.data.addDataForFlavour("text/html",'html');
			transferData.data.addDataForFlavour("text/x-moz-url",'url');
			transferData.data.addDataForFlavour("text/unicode",'unicode');
			transferData.data.addDataForFlavour("application/x-moz-file",'file');
	 },


	 getSupportedFlavours: function(){
			flavors=new FlavourSet();
			//flavors.appendFlavour('flock/shelfobject');
			flavors.appendFlavour('text/unicode');
			flavors.appendFlavour('text/html');
			flavors.appendFlavour('text/x-moz-url');
			flavors.appendFlavour('application/x-moz-file','nsIFile');
			return flavors;
	 }
}

var shelfObjObserver={
	 onDragStart: function(event, transferData, action){
		try{
			/*
			for(i in event.target.session){
				dump('==> ET: ' + i + ': ' + event.target.session[i] + '\n');
			}
			dump('SOURCE NODE: ' + event.target.sourceNode + '\n');
			*/
			src=event.target.src;
			dump('DRAGGING SOURCE: ' + src + '\n');
			transferData.data=new TransferData();
			transferData.data.addDataForFlavour("flock/shelfobject",src);
			transferData.data.addDataForFlavour("text/html",src);
			transferData.data.addDataForFlavour("text/unicode",src);
		}
		catch(e){
			bail(e,'shelfobjobserver');
		}
	 }
}

function adjust_shelfobject_sizes(){
	shelf_box=document.getElementById('shelf_box');
	shelf_box.setAttribute('height',window.innerHeight);

	elms=document.getElementsByTagName('shelfobject');
	dump('===> ' + elms.length + ' shelf objects to resize to ' + window.innerWidth + '.\n');
	for(i=0; i<elms.length; i++){
		/*
		for(j=0; j<elms[i].length; j++){
			elms[i].childNodes[j].setAttribute('width',window.innerWidth - 95); //Should make this dynamic. For now, it's the image width plus padding. XXX
		}
		*/
		elms[i].width=window.innerWidth - 95; //Should make this dynamic. For now, it's the image width plus padding. XXX
	}
}

function init_shelf(){
	toggleViewMenu();
	 try{
		window.addEventListener('resize',adjust_shelfobject_sizes,true);
		var rdf='<?xml version="1.0"?>' +
			 '<RDF:RDF xmlns:NS1="http://www.flock.com/rdf#"' +
			 '		 xmlns:RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#">' +
			 '	<RDF:Seq about="urn:flock:shelf:objects">' +
			 '	</RDF:Seq>' + 
			 '</RDF:RDF>';

		window.ds=null;

		var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
		var profileDir = dirService.get('ProfD', Components.interfaces.nsILocalFile);
		window.fileObj = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		window.fileObj.initWithPath(profileDir.path);
		window.fileObj.append('shelf.rdf');

		if(!window.fileObj.exists()){
			_flock_write_file(rdf,window.fileObj.path);
		}
		window.ds=new RDFDataSource('file://' + window.fileObj.path,rdf_loaded);

			//alert('Shelf initialized!');
	 }
	 catch(e){
		bail(e,'init_shelf');
		//alert('init_shelf: ' + e);
	 }
}

function rdf_loaded(ds){
	try{
		elm=document.getElementById('shelf_box');	
		//resources=ds.getAllResources();
		var container=ds.getNode("urn:flock:shelf:objects");
		var resources=container.getChildren();
		if(container.getChildCount()==0){
			document.getElementById('shelf_instructions').setAttribute('hidden','false');
		}

		while(resources.hasMoreElements()){
			obj=document.createElement('shelfobject');
			resource=resources.getNext();
			properties=resource.getProperties();
			while(properties.hasMoreElements()){
				prop=properties.getNext();
				parts=prop.getValue().split('#');
				lit=resource.getTarget(prop.getValue());
				obj.setAttribute(parts[1],lit.getValue());
				if(parts[1]=='src'){
					obj.src=lit.getValue();
				}
			}
			//obj.className='normal';
			obj.addEventListener('draggesture',function(event){ nsDragAndDrop.startDrag(event,shelfObjObserver); },true);
			if(obj.getAttribute('label')){
				elm.appendChild(obj);
			}
		}
		adjust_shelfobject_sizes();
	}
	catch(e){
		//alert('rdf_loaded: ' + e);
		bail(e,'rdf_loaded');
	}
}

function add_object(obj){
	try{
		var date=new Date();
		var container=window.ds.getNode("urn:flock:shelf:objects");

		document.getElementById('shelf_instructions').setAttribute('hidden','true');

		if(typeof window.next_shelfobject == "undefined" || !window.next_shelfobject){
			idx=1;
		}
		else{
			//Get node this is being dropped in front of (set in xbl ondragenter handler) and its index.
			var nextnode=window.ds.getNode('urn:flock:shelf:' + window.next_shelfobject.id);
			var idx=container.getChildIndex(nextnode);
			//Destroy this object or you get errors if you delete everything from the shelf and try to drag something else onto it.
		}

		dump('INSERTING shelfobject at idx ' + idx + '\n');

		var child=window.ds.getNode("urn:flock:shelf:" + obj.id);
		container.addChildAt(child,idx);
		for(i=0; i<obj.attributes.length; i++){
			child.addTarget("http://www.flock.com/rdf#" + obj.attributes[i].name,obj.attributes[i].value);
		}
		child.addTarget("http://www.flock.com/rdf#src",obj.src);
		//child.addTarget("http://www.flock.com/rdf#id",'obj_' + num);

		status=window.ds.save();
		//dump(window.ds.serializeToString()); 
		window.next_shelfobject='';//null;
	}
	catch(e){
		bail(e,'add_object');
	}
}


function flush_shelf(){
	elm=document.getElementById('shelf_box');	
	for(i=elm.childNodes.length-1; i>=0; i--){
		if(elm.childNodes[i].nodeName=='shelfobject'){
			elm.removeChild(elm.childNodes[i]);
		}
	}
	window.ds.deleteRecursive("urn:flock:shelf:objects");
	node=window.ds.getNode("urn:flock:shelf:objects");
	node.makeSeq();
	window.ds.save();

	document.getElementById('shelf_instructions').setAttribute('hidden','false');

}

function delete_shelfobject(event){
	try{
		//Look for delete button or backspace key.
		//if((event.keyCode==8 || event.keyCode==46) && typeof window.selected_shelfobject == "object"){
		if(typeof window.selected_shelfobject=='object' && (arguments[1] || (event.keyCode==8 || event.keyCode==46))){
			dump('Deleting ' + window.selected_shelfobject.id + '\n');
			elm=document.getElementById(window.selected_shelfobject.id);
			//Only execute if we actually found an element.
			if(elm){
				obj=null;
				//Get the rdf node's index within its container.
				elm.parentNode.removeChild(elm);
				var container=window.ds.getNode("urn:flock:shelf:objects");
				var objectnode=window.ds.getNode('urn:flock:shelf:' + window.selected_shelfobject.id);
				var idx=container.getChildIndex(objectnode);
			
				dump('SHELF IDX: ' + idx + '\n');

				//See how many children we've got so we can display the instructions if we've deleted them all. Just using getChildCount() doesn't work for some reason. I know this is redundant with the loop below. Too bad for now.
				var cnt=0;
				var children=container.getChildren();
				while(children.hasMoreElements()){
					var tmp=children.getNext();
					cnt++;
				}
				dump('CNT: ' + cnt + '\n');
				if(cnt==1){
					document.getElementById('shelf_instructions').setAttribute('hidden','false');
				}

				//Now delete the node from the rdf.	
				window.ds.deleteRecursive(objectnode);
				container.removeChild(objectnode);
				window.ds.save();
				dump('SHELF: Saved ds.\n');

				//Now iterate over the remaining nodes in the container.
				if(container.getChildCount() > 0 && idx >= 1){
					var children=container.getChildren();
					while(children.hasMoreElements()){
						var child=children.getNext();
						var child_idx=container.getChildIndex(child);
						dump('SHELF: child_idx: ' + child_idx + '\n');
						//If the current is greater than the idx (which id we've deleted), select it and break.
						if(container.getChildIndex(child) >= idx){
							dump('=== > SHELF: child_idx matches!\n');
							literal=child.getTarget('http://www.flock.com/rdf#id');
							dump('SHELF: literal: ' + literal.getValue() + '\n');
							obj=document.getElementById(literal.getValue());
							break;
						}
					}
				}
				else{
					//alert('No more children to delete!');
				}
			}
			else{
				dump('Hey, there was an error trying to delete an element.\n');
			}
		}
	
		elements=document.getElementsByTagName('shelfobject');	
		if(elements.length > 0){
			elements[0].alternate();
		}
		if(obj && typeof obj == "object" && obj.select){
			obj.select();
		}
		else{
			dump('Could not select object ' + typeof obj + '\n');
		}
	}
	catch(e){
		bail(e,'delete_shelfobject');
	}
}


function _flock_write_file(str_Buffer,str_Filename){
	dump('Got to _sb_write_file: ' + str_Filename + '\n');
	try{
		var obj_File = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		obj_File.initWithPath(str_Filename);
		if(!obj_File.exists())
			obj_File.create(0x00,0644);
	}
	catch(e){
		alert(e);
	}
	try {
		var obj_Transport = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		obj_Transport.init( obj_File, 0x04 | 0x08 | 0x10, 064, 0 );
		obj_Transport.write(str_Buffer,str_Buffer.length);
		obj_Transport.close();
	}
	catch(e){
		alert(e);
	}
}

function bail(e){
	prefix='';
	if(arguments[1]){
		prefix='[' + arguments[1] + '] ';
	}
	for(i in e){
		txt += i + ': ' + e[i] + '\n';
	}
	dump('================\n' + prefix + txt + '\n=================\n');
}

function toggleViewMenu(){
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("navigator:browser");

	viewMenu=topWindow.document.getElementById('menu_viewPopup');
	viewMenu.parentNode.disabled=!viewMenu.disabled;
}
