/*
 * BEGIN FLOCK GPL
 * 
 * Copyright Flock Inc. 2005
 * http://flock.com
 * 
 * This file may be used under the terms of of the
 * GNU General Public License Version 2 or later (the "GPL"),
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 * 
 * END FLOCK GPL
 */

/*
 * Doin' Stuff(tm)
 */
function flock_groupInit() {
    groupInit = new FlockJax();
    groupInit.onResponse = flock_handleGroupInitResponse;
    groupInit.onComplete = function () {
        $("topbarGroups-loading").style.display = "none";    
    }
    groupInit.onError = function () {
        $("topbarGroups-errorText").value = "You must be logged in to see this data, please refresh to try again.";
        $("topbarGroups-error").style.display = "";
    }
    groupInit.request(FLOCK_API+"/groups/getList");
}

function flock_addBreadcrumbToGroup(aTarget,aUrl,aTitle,aDesc) {
    // XXX andy: We need a better way to get to this info,
    //  I thought this.groupid might work, but it didn't seem to
    if (aTarget.getAttribute("groupid")) {
        groupid = aTarget.getAttribute("groupid");
    } else {
        groupid = aTarget.parentNode.getAttribute("groupid");
    }

    var addBcToGroupUrl = FLOCK_API+"/groups/addBreadcrumb?group_id="+groupid+"&url="+flock_escape(aUrl)+"&title="+flock_escape(aTitle)+"&desc="+flock_escape(aDesc);
    

    addBcToGroup = new FlockJax();
    addBcToGroup.onResponse = flock_handleAddBreadcrumbToGroupResponse;
    addBcToGroup.request(addBcToGroupUrl);
}

function flock_gotoGroup(aTarget) {
    // XXX andy: We need a better way to get to this info,
    //  I thought this.groupid might work, but it didn't seem to
    if (aTarget.getAttribute("groupid")) {
        groupid = aTarget.getAttribute("groupid");
    } else {
        groupid = aTarget.parentNode.getAttribute("groupid");
    }
    window.parent.loadURI(FLOCK_WEB+"/group/show/"+groupid);
}

/*
 * Ajax response handling functions
 */
function flock_handleGroupInitResponse(aRes) {
    // Get the list of groups from the response
    $("topbarGroups-error").style.display = "none";
    var groupList = aRes.responseXML.getElementsByTagName("group");
    if (!groupList.length) {
        flock_notifyUser("No groups were returned");
        return;
    }
    // Build the DataSource and add the groups to it
    var groupDS = new RDFDataSource();
    var groupDSRoot = groupDS.getNode(FLOCK_GROUP_URN);
    groupDSRoot.makeSeq();
    for (var i = 0; i < groupList.length; i++) {
        curGroup = groupList[i];
        XXX("CURGROUP:"+curGroup);
        newNode = groupDS.getNode(FLOCK_GROUP_URN+":"+curGroup.getAttribute("id"));
        newNode.addTargetOnce(_ns('groupid'), curGroup.getAttribute("id"));
        newNode.addTargetOnce(_ns('avatar'), curGroup.getAttribute("avatar"));
        newNode.addTargetOnce(_ns('name'), curGroup.getAttribute("name"));
        groupDSRoot.addChild(newNode);
    }
    var groupsBox = $("topbarGroups-box");
    groupsBox.database.AddDataSource(groupDS.getRawDataSource());
    groupsBox.ref = FLOCK_GROUP_URN;
    groupsBox.builder.rebuild();
}


function flock_handleAddBreadcrumbToGroupResponse(aRes) {
    // flock_addBreadcrumbToLocal
    XXX("Successfully added this breadcrumb to the group");
}

/*
 * The drag and drop observer for the groups
 */
var groupDNDObserver = new DNDObserver();

groupDNDObserver.onDragStart = function (aEvent, aXferData, aDragAction) {
    var name = aEvent.target.getAttribute("name");
    if (aEvent.target.getAttribute("groupid")) {
        groupid = aEvent.target.getAttribute("groupid");
    } else {
        groupid = aEvent.target.parentNode.getAttribute("groupid");
    }
    aXferData.data = new TransferData();
    aXferData.data.addDataForFlavour("text/x-moz-url", FLOCK_WEB + "/rss/group/" + groupid + "\n" + name);

}

groupDNDObserver.onDrop = function (aEvent, aXferData, aDragSession) {
        // Use this to send the dropped item to the group
        // If it is a url send it to the group, if it is
        // text, check if it is a url and then send
        XXX("Received a drop");
        arDropped = aXferData.data.split("\n");
        url = arDropped[0];
        title = arDropped[1];
        XXX("Received url: "+url);
        XXX("Received title: "+title);
        flock_addBreadcrumbToGroup(aEvent.target,url, title);
}

groupDNDObserver.getSupportedFlavours = function () {
        var flavourSet = new FlavourSet();
        flavourSet.appendFlavour("text/x-moz-url");
        return flavourSet;                           
}
