//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

const PREFS = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefBranch);
const FAVES = Components.classes["@mozilla.org/rdf/datasource;1?name=flock-favorites"].getService (Components.interfaces.flockIFavoritesService);

function flock_services_tabs_changed() {
    $("webServiceEnabled").checked = FAVES.getWebServiceEnabled ();
    $("addAndTagByDefault").checked = PREFS.getBoolPref ('flock.favorites.addAndTagByDefault');
}

function flock_setWebServiceEnabled () {
    FAVES.setWebServiceEnabled ($('webServiceEnabled').checked);
    PREFS.setBoolPref ('flock.favorites.askedAboutSharing', true);
    if ($('webServiceEnabled').checked) {
        FAVES.syncUp ();
        FAVES.syncDown ();
    }
}

function flock_setAddAndTagByDefault() {
    PREFS.setBoolPref ('flock.favorites.addAndTagByDefault', $("addAndTagByDefault").checked);
}
